--{{{  interpret iterm line with 2 arguments
PROC interpret.iterm.2.arg (VAL INT arg1, arg2, []BYTE command, INT len)
  BOOL arg, adj:
  SEQ
    len := 0
    arg := FALSE
    adj := FALSE
    SEQ i=0 FOR SIZE s.goto
      IF
        arg
          --{{{  this item is an argument
          SEQ
            arg := FALSE
            adj := TRUE
          --}}}  
        adj
          --{{{  this item is an adjustment
          --{{{  abbreviations
          VAL desc          IS INT s.goto[i-1]:
          VAL arg.no        IS desc / 10:
          VAL byte.arg      IS (desc \ 10) = 1:
          VAL raw.argument  IS [arg1, arg2][arg.no - 1]:
          VAL argument      IS raw.argument + (INT s.goto[i]):
          --}}}  
          SEQ
            --{{{  set up command
            IF
              byte.arg
                SEQ
                  command[len] := BYTE argument
                  len := len + 1
              TRUE
                VAL zero IS INT '0':
                SEQ
                  IF
                    (argument / 10) > 0
                      SEQ
                        command[len]   := BYTE ((argument/10) + zero)
                        len := len + 1
                    TRUE
                      SKIP
                  command[len] := BYTE ((argument\10) + zero)
                  len := len + 1
            --}}}  
          
            adj := FALSE
          --}}}  
        s.goto[i] = iterm.arg
          --{{{  next item is an argument
          arg := TRUE
          --}}}  
        TRUE
          --{{{  no arguments in sight
          SEQ
            command[len] := s.goto[i]
            len := len + 1
          --}}}  
:
--}}}  

--{{{  screen clear
PROC screen.clear(CHAN OF SP fs, ts)
  so.write.string(fs, ts, s.cls)
:
--}}}  
--{{{  clear screen
PROC Clear.Screen(CHAN OF SP fs, ts)
  SEQ
    screen.clear(fs, ts)
:
--}}}  
--{{{  screen clear eos
PROC screen.clear.eos (CHAN OF SP fs, ts)
  so.write.string(fs, ts, s.clr.eos)
:
--}}}  
--{{{  screen clear eol
PROC screen.clear.eol (CHAN OF SP fs, ts)
  so.write.string(fs, ts, s.clr.eol)
:
--}}}  

--{{{  screen cursor up
PROC screen.cursor.up (CHAN OF SP fs, ts)
  so.write.string (fs, ts, s.up)
:
--}}}  
--{{{  screen cursor down
PROC screen.cursor.down (CHAN OF SP fs, ts)
  so.write.string (fs, ts, s.down)
:
--}}}  
--{{{  screen cursor left
PROC screen.cursor.left (CHAN OF SP fs, ts, VAL INT col.width)
  SEQ i=0 FOR col.width
    so.write.string(fs, ts, s.left)
:
--}}}  
--{{{  screen cursor right
PROC screen.cursor.right (CHAN OF SP fs, ts, VAL INT col.width)
  SEQ i=0 FOR col.width
    so.write.string(fs, ts, s.right)
:
--}}}  
--{{{  screen backspace
PROC screen.backspace (CHAN OF SP fs, ts)
  so.write.string (fs, ts, s.left)
:
--}}}  

--{{{  screen goto xy
PROC screen.goto.xy (CHAN OF SP fs, ts, VAL INT col, row)
  [SIZE s.goto]BYTE command:
  INT len:
  SEQ
    interpret.iterm.2.arg (col, row, command, len)
    so.write.string (fs, ts, [command FROM 0 FOR len])
:
--}}}  
--{{{  screen goto
PROC screen.goto (CHAN OF SP fs, ts, VAL INT line, col, VAL BOOL hex)

  VAL screen.line IS line + header.lines:
  INT screen.column:
  SEQ
    IF
      hex
        screen.column := hex.start + (col * col.width)
      TRUE
        screen.column := ascii.start + col
    screen.goto.xy (fs, ts, screen.column, screen.line)
:
--}}}  
--{{{  screen goto address
PROC screen.goto.address (CHAN OF SP fs, ts, VAL INT line)
  VAL screen.column IS address.start:
  VAL screen.line   IS line + header.lines:
  screen.goto.xy (fs, ts, screen.column, screen.line)
:
--}}}  

--{{{  screen write spaces
PROC screen.write.spaces (CHAN OF SP fs, ts, VAL INT n)
  VAL spaces IS "                                          ":
  so.write.string (fs, ts, [spaces FROM 0 FOR n])
:
--}}}  
--{{{  screen title
PROC screen.title (CHAN OF SP fs, ts, VAL INT line, VAL []BYTE string)
  VAL spaces IS (screen.width - (SIZE string))/2:
  SEQ
    screen.goto.xy (fs, ts, 0, line)
    screen.clear.eol (fs, ts)
    screen.write.spaces (fs, ts, spaces)
    so.write.string.nl (fs, ts, string)
:
--}}}  
--{{{  screen header
PROC screen.header (CHAN OF SP fs, ts,
                  VAL INT address, VAL BOOL read.write, first.page, last.page,
                  VAL INT row, col)
  [screen.width]BYTE line:
  INT next:
  SEQ
    --{{{  initialise
    next := 0
    --}}}  
    --{{{  address
    SEQ
      append.text (next, line, "Address: ")
      append.hex.int (next, line, address, address.digits)
    --}}}  
    --{{{  read only or read/write
    SEQ
      IF
        read.write
          append.text (next, line, "  Read/write")
        TRUE
          append.text (next, line, "  Read only")
    
    --}}}  
    --{{{  line and column
    SEQ
      append.text (next, line, "  Line: ")
      append.int (next, line, row + 1, 0)
      append.text (next, line, "  Column: ")
      append.int (next, line, col + 1, 0)
    --}}}  
    --{{{  first page and last page
    SEQ
      IF
        first.page
          append.text (next, line, "  First page")
        TRUE
          SKIP
      IF
        last.page
          append.text (next, line, "  Last page")
        TRUE
          SKIP
    --}}}  
    screen.title (fs, ts, title.lines, [line FROM 0 FOR next])
:
--}}}  
--{{{  screen prompt
PROC screen.prompt (CHAN OF SP fs, ts, VAL []BYTE string)
  SEQ
    screen.goto.xy (fs, ts, 0, prompt.line)
    screen.clear.eol (fs, ts)
    so.write.string (fs, ts, string)
:
--}}}  
--{{{  screen write hex byte
PROC screen.write.hex.byte (CHAN OF SP fs, ts, VAL BYTE b)
  VAL INT ms.nibble IS (INT b) / 16:
  VAL INT ls.nibble IS (INT b) \ 16:
  VAL hex.digits IS ['0', '1', '2', '3', '4', '5', '6', '7', '8',
                          '9', 'A', 'B', 'C', 'D', 'E', 'F']:
  VAL BYTE ms.char  IS hex.digits[ms.nibble]:
  VAL BYTE ls.char  IS hex.digits[ls.nibble]:
  so.write.string (fs, ts, [ms.char, ls.char, '*s'])
:
--}}}  
--{{{  screen write ascii
PROC screen.write.ascii (CHAN OF SP fs, ts, []BYTE string)
  SEQ
    SEQ i=0 FOR SIZE string
      IF
        is.in.range (string[i], '*s', '~')
          SKIP
        TRUE
          string[i] := '.'
    so.write.string (fs, ts, string)

:
--}}}  
--{{{  screen display line
PROC screen.display.line (CHAN OF SP fs, ts, VAL []BYTE data, INT start.address,
                   VAL INT line, cols)
  [no.cols]BYTE data.line:
  SEQ
    [data.line FROM 0 FOR cols] := [data FROM start.address FOR cols]
    screen.goto.address (fs, ts, line)
    screen.clear.eol (fs, ts)
    so.write.hex.int (fs, ts, start.address, address.digits)
    VAL hex IS TRUE:
    SEQ i = 0 FOR cols
      SEQ
        screen.goto (fs, ts, line, i, hex)
        screen.write.hex.byte (fs, ts, data.line[i])
    VAL ascii IS FALSE:
    screen.goto (fs, ts, line, 0, ascii)
    screen.write.ascii (fs, ts, [data.line FROM 0 FOR cols])
    start.address := start.address + cols
:
--}}}  
--{{{  screen refresh
PROC screen.refresh (CHAN OF SP fs, ts, VAL []BYTE data,
         VAL INT start.address, cur.line, full.lines, cur.col, part.line.cols,
         VAL BOOL part.line, hex)
  -- refreshes data part of screen
  INT address:
  SEQ
    address := start.address
    SEQ line = 0 FOR full.lines
      screen.display.line (fs, ts, data, address, line, no.cols)
    IF
      part.line
        VAL line IS full.lines:
        screen.display.line (fs, ts, data, address, line, part.line.cols)
      TRUE
        SKIP
    screen.goto (fs, ts, cur.line, cur.col, hex)
:
--}}}  

--{{{  screen change ascii (from hex)
PROC screen.change.ascii (CHAN OF SP fs, ts, VAL INT line, col, VAL BYTE ch)
  [1]BYTE string:
  VAL hex IS TRUE:
  VAL ascii IS FALSE:
  SEQ
    screen.goto (fs, ts, line, col, ascii)
    string[0] := ch
    screen.write.ascii (fs, ts, string)
    screen.goto (fs, ts, line, col, hex)
:
--}}}  
--{{{  screen change hex   (from ascii)
PROC screen.change.hex (CHAN OF SP fs, ts, VAL INT line, col, VAL BYTE ch)
  VAL hex IS TRUE:
  VAL ascii IS FALSE:
  SEQ
    screen.goto (fs, ts, line, col, hex)
    screen.write.hex.byte (fs, ts, ch)
    screen.goto (fs, ts, line, col, ascii)
:
--}}}  

--{{{  read key
PROC read.key (CHAN OF SP fs, ts, INT key, BOOL special, ok)
  --{{{  is equal
  BOOL FUNCTION is.equal (VAL []INT input, iterm, VAL INT len)
    BOOL equal:
    VALOF
      IF
        len > iterm[1]
          equal := FALSE
        IF i=0 FOR len
          input[i] <> iterm[i+2]
            equal := FALSE
        TRUE
          equal := TRUE
      RESULT equal
  :
  --}}}  
  BYTE byte.key, result:
  SEQ
    so.getkey (fs, ts, byte.key, result)
    IF
      result = spr.ok
        --{{{  key read ok
        SEQ
          key := INT byte.key
          ok := TRUE
          IF
            IF i=0 FOR no.special.keys
              key = special.key[i][2]
                --{{{  found special key
                [max.key.seq]INT key.seq:
                INT len, j:
                SEQ
                  j := i
                  special := TRUE
                  key.seq[0] := key
                  key := special.key[j][0]
                  len := 1
                  WHILE (len < special.key[j][1]) AND ok
                    SEQ
                      so.getkey (fs, ts, byte.key, result)
                      IF
                        result = spr.ok
                          --{{{  key read ok
                          SEQ
                            key.seq[len] := INT byte.key
                            len := len + 1
                            IF
                              IF m=j FOR no.special.keys-j
                                is.equal (key.seq, special.key[m], len)
                                  SEQ
                                    key := special.key[m][0]
                                    j := m
                              TRUE
                                ok := FALSE
                          --}}}  
                        TRUE
                          ok := FALSE
                
                
                
                --}}}  
            TRUE
              special := FALSE
        --}}}  
      TRUE
        ok := FALSE
:
--}}}  

--{{{  Centred.Text
PROC Centred.Text(VAL []BYTE Text, []BYTE Centred.Text)
  VAL INT Screen.Width IS SIZE Centred.Text:
  VAL INT Middle.Of.Screen IS Screen.Width / 2:
  VAL INT Length IS SIZE Text:
  VAL INT Middle IS Length / 2:
  VAL INT Start  IS Middle.Of.Screen - (Middle):
  SEQ
    SEQ i = 0 FOR Screen.Width
      Centred.Text[i] := ' '
    [Centred.Text FROM Start FOR Length] := Text
:
--}}}  
--{{{  Blank.Line
PROC Blank.Line(CHAN OF SP fs, ts, VAL INT Line.Count)
  SEQ
    SEQ i = 0 FOR Line.Count
      so.write.nl(fs, ts)
:
--}}}  
--{{{  Display.Line
--{{{  Verbos Form
PROC Display.Line(CHAN OF SP fs, ts, VAL []BYTE Line)
  [80]BYTE Display.Line:
  SEQ
    Centred.Text(Line, Display.Line)
    so.write.string(fs, ts, Display.Line)
:
--}}}  
--{{{  Short Form
PROC dl(CHAN OF SP fs, ts, VAL []BYTE Line)
  SEQ
    Display.Line(fs, ts, Line)
:
--}}}  
--}}}  
--{{{  Display.Under.Scored.Line
PROC Display.Under.Scored.Line(CHAN OF SP fs, ts,
                               VAL []BYTE Line,
                               VAL BYTE   Under.Score)
  [80]BYTE Display.Line:
  [80]BYTE Under.Scored.Line:
  SEQ
    Centred.Text(Line, Display.Line)
    so.write.string(fs, ts, Display.Line)
    SEQ i = 0 FOR SIZE Line
      Under.Scored.Line[i] := Under.Score
    []BYTE temp RETYPES [Under.Scored.Line FROM 0 FOR (SIZE Line)]:
    Centred.Text(temp, Display.Line)
    so.write.string(fs, ts, Display.Line)
:
--}}}  
--{{{  Display Options
PROC Display.Options(CHAN OF SP fs, ts,
                     VAL []BYTE Header,
                     VAL []BYTE Title,
                     VAL [][]BYTE Options,
                     VAL []BYTE Footer,
                     INT Selected.Option)

  VAL INT Option.Count IS SIZE Options:
  SEQ
    Clear.Screen(fs, ts)
    Display.Line(fs, ts, Header)
    so.write.nl(fs, ts)
    Display.Line(fs, ts, Title)
    so.write.nl(fs, ts)
    --{{{  Display Options
    SEQ Option = 0 FOR SIZE Options
      SEQ
        so.write.int(fs, ts, Option, 5)
        so.write.string(fs, ts, " : ")
        so.write.string.nl(fs, ts, Options[Option])
        IF
          Option = 0
            so.write.nl(fs, ts)
          TRUE
            SKIP
    --}}}  
    so.write.nl(fs, ts)
    screen.goto.xy (fs, ts, 1, 21)
    Display.Line(fs, ts, Footer)
    --{{{  Get User Option
    BYTE Key, Result:
    SEQ
      Selected.Option := -1
      so.write.string(fs, ts, "  > ")
      WHILE ((Selected.Option < 0) OR (Selected.Option > (Option.Count-1)))
        SEQ
          so.getkey(fs, ts, Key, Result)
          IF
            Result = 0 (BYTE)
              Selected.Option := (INT Key) - 48
            TRUE
              Selected.Option := -1
    --}}}  
    Clear.Screen(fs, ts)
:
--}}}  
--{{{  Press Any Key to Continue
PROC Press.Any.Key.To.Continue(CHAN OF SP fs, ts)
  BYTE Key, Result:
  SEQ
    Display.Line(fs, ts, "Press any key to continue")
    so.getkey(fs, ts, Key, Result)
:
--}}}  
--{{{  Activity Monitor
PROC Activity.Monitor(CHAN OF SP fs, ts,
                      INT Compass.Direction,
                      VAL INT Delay)
  SEQ
    --{{{  Display Acitivity
    CASE Compass.Direction
      0
        so.write.char(fs, ts, '|')
      1
        so.write.char(fs, ts, '/')
      2
        so.write.char(fs, ts, '-')
      3
        so.write.char(fs, ts, '\')
      4
        so.write.char(fs, ts, '|')
      5
        so.write.char(fs, ts, '/')
      6
        so.write.char(fs, ts, '-')
      7
        so.write.char(fs, ts, '\')
      ELSE
        so.write.char(fs, ts, '?')
    TIMER Clock:
    INT   Time, Delay.Time:
    SEQ
      Clock ? Time
      Delay.Time := Time PLUS Delay
      Clock ? AFTER (Delay.Time)
    so.write.char(fs, ts, '*c')
    Compass.Direction := ((Compass.Direction + 1) /\ 7)
    --}}}  
:
--}}}  
