--{{{  Clear Screen
PROC Clear.Screen()
  VAL []BYTE CLS IS [27(BYTE), 91(BYTE), 50(BYTE), 74(BYTE)]:
  SEQ
    so.write.string(fs, ts, CLS)
:
--}}}
--{{{  Centred.Text
PROC Centred.Text(VAL []BYTE Text, []BYTE Centred.Text)
  VAL INT Screen.Width IS SIZE Centred.Text:
  VAL INT Middle.Of.Screen IS Screen.Width / 2:
  VAL INT Length IS SIZE Text:
  VAL INT Middle IS Length / 2:
  VAL INT Start  IS Middle.Of.Screen - (Middle):
  SEQ
    SEQ i = 0 FOR Screen.Width
      Centred.Text[i] := ' '
    [Centred.Text FROM Start FOR Length] := Text
:
--}}}
--{{{  nl -- New Line
PROC nl()
  SEQ
    so.write.nl(fs, ts)
:
--}}}
--{{{  ws -- write.string
PROC ws(VAL []BYTE the.string)
  SEQ
    so.write.string(fs, ts, the.string)
:
--}}}
--{{{  wc -- write.char
PROC wc(VAL BYTE the.char)
  SEQ
    so.write.char(fs, ts, the.char)
:
--}}}
--{{{  wsnl -- write.string.nl
PROC wsnl(VAL []BYTE the.string)
  SEQ
    so.write.string.nl(fs, ts, the.string)
:
--}}}
--{{{  wi -- Write Int
PROC wi(VAL INT int, width)
  SEQ
    so.write.int(fs, ts, int, width)
:
--}}}
--{{{  whi -- Write Hex Int
PROC whi(VAL INT int, width)
  SEQ
    so.write.hex.int(fs, ts, int, width)
:
--}}}
--{{{  Display.Line
--{{{  Verbos Form
PROC Display.Line(VAL []BYTE Line)
  [80]BYTE Display.Line:
  SEQ
    Centred.Text(Line, Display.Line)
    so.write.string(fs, ts, Display.Line)
:
--}}}
--{{{  Short Form
PROC dl(VAL []BYTE Line)
  SEQ
    Display.Line(Line)
:
--}}}
--}}}
--{{{  Display Options
PROC Display.Options(VAL []BYTE Header,
                     VAL []BYTE Title,
                     VAL [][]BYTE Options,
                     VAL []BYTE Footer,
                     INT Selected.Option)

  VAL INT Option.Count IS SIZE Options:
  SEQ
    Clear.Screen()
    Display.Line(Header)
    so.write.nl(fs, ts)
    Display.Line(Title)
    so.write.nl(fs, ts)
    --{{{  Display Options
    SEQ Option = 0 FOR SIZE Options
      SEQ
        so.write.int(fs, ts, Option, 5)
        so.write.string(fs, ts, " : ")
        so.write.string.nl(fs, ts, Options[Option])
        IF
          Option = 0
            so.write.nl(fs, ts)
          TRUE
            SKIP
    --}}}
    so.write.nl(fs, ts)
    screen.goto.xy (fs, ts, 1, 23)
    Display.Line(Footer)
    --{{{  Get User Option
    BYTE Key, Result:
    SEQ
      Selected.Option := -1
      WHILE ((Selected.Option < 0) OR (Selected.Option > (Option.Count-1)))
        SEQ
          so.getkey(fs, ts, Key, Result)
          IF
            Result = 0 (BYTE)
              Selected.Option := (INT Key) - 48
            TRUE
              Selected.Option := -1
    --}}}
:
--}}}
--{{{  Press Any Key to Continue
PROC Press.Any.Key.To.Continue()
  BYTE Key, Result:
  SEQ
    Display.Line("Press any key to continue")
    so.getkey(fs, ts, Key, Result)
:
--}}}
--{{{  Activity Monitor
PROC Activity.Monitor(INT Compass.Direction,
                      VAL INT Delay)
  SEQ
    --{{{  Display Acitivity
    CASE Compass.Direction
      0
        so.write.char(fs, ts, '|')
      1
        so.write.char(fs, ts, '/')
      2
        so.write.char(fs, ts, '-')
      3
        so.write.char(fs, ts, '\')
      4
        so.write.char(fs, ts, '|')
      5
        so.write.char(fs, ts, '/')
      6
        so.write.char(fs, ts, '-')
      7
        so.write.char(fs, ts, '\')
      ELSE
        so.write.char(fs, ts, '?')
    TIMER Clock:
    INT   Time, Delay.Time:
    SEQ
      Clock ? Time
      Delay.Time := Time PLUS Delay
      Clock ? AFTER (Delay.Time)
    so.write.char(fs, ts, '*c')
    Compass.Direction := ((Compass.Direction + 1) /\ 7)
    --}}}
:
--}}}
--{{{  Display Execution Status Only
PROC Display.Execution.Status( VAL INT16 Execution.Status)
  SEQ
    IF
      ((INT Execution.Status) <> (INT SCSI.E.Good))
        SEQ
          --{{{  Display Status
          so.write.string(fs, ts, " Error : Execution.Status = ")
          CASE Execution.Status
            --{{{  Display Appropriate Message
            SCSI.E.Good
              so.write.string.nl(fs, ts, "Good  ")
            SCSI.E.Bad.SCSI.Status
              so.write.string.nl(fs, ts, "Bad.SCSI.Status")
            SCSI.E.Command.Not.Complete
              so.write.string.nl(fs, ts, "Command.Not.Complete ")
            SCSI.E.Incorrect.IO.Process.Number
              so.write.string.nl(fs, ts, "Incorrect.IO.Process.Number")
            SCSI.E.SCSI.Bus.Parity.Error
              so.write.string.nl(fs, ts, "SCSI.Bus.Parity.Error")
            SCSI.E.Data.In.Failure
              so.write.string.nl(fs, ts, "Data.In.Failure")
            SCSI.E.Bad.Data.In.Returned.Packet.Size
              so.write.string.nl(fs, ts, "Bad.Data.In.Returned.Packet.Size ")
            SCSI.E.Data.Out.Failure
              so.write.string.nl(fs, ts, "Data.Out.Failure  ")
            SCSI.E.Bad.Data.Out.Returned.Packet.Size
              so.write.string.nl(fs, ts, "Bad.Data.Out.Returned.Packet.Size")
            SCSI.E.Data.In.Time.Out
              so.write.string.nl(fs, ts, "Data.In.Time.Out  ")
            SCSI.E.Data.Out.Time.Out
              so.write.string.nl(fs, ts, "Data.Out.Time.Out ")
            SCSI.E.Command.Time.Out
              so.write.string.nl(fs, ts, "Command.Time.Out  ")
            SCSI.E.Status.Time.Out
              so.write.string.nl(fs, ts, "Status.Time.Out")
            SCSI.E.Controller.Reset.Time.Out
              so.write.string.nl(fs, ts, "Controller.Reset.Time.Out  ")
            SCSI.E.Bus.Reset.Time.Out
              so.write.string.nl(fs, ts, "Bus.Reset.Time.Out")
            SCSI.E.Reselected
              so.write.string.nl(fs, ts, "Reselected  ")
            SCSI.E.Function.Not.Complete
              so.write.string.nl(fs, ts, "Function.Not.Complete")
            SCSI.E.Disconnected
              so.write.string.nl(fs, ts, "Disconnected")
            SCSI.E.Not.Bus.Service
              so.write.string.nl(fs, ts, "Not.Bus.Service")
            SCSI.E.Sequence.Not.Complete
              so.write.string.nl(fs, ts, "Sequence.Not.Complete")
            SCSI.E.Premature.Phase.Change
              so.write.string.nl(fs, ts, "Premature.Phase.Change  ")
            SCSI.E.Target.Did.Not.Assert.ATN
              so.write.string.nl(fs, ts, "Target.Did.Not.Assert.ATN  ")
            SCSI.E.Target.Did.Not.Assert.Message.Out
              so.write.string.nl(fs, ts, "Target.Did.Not.Assert.Message.Out")
            SCSI.E.Selection.Time.Out
              so.write.string.nl(fs, ts, "Selection.Time.Out")
            SCSI.E.Undocumented.Error
              so.write.string.nl(fs, ts, "Undocumented.Error")
            SCSI.E.Data.In.Abort
              so.write.string.nl(fs, ts, "Data.In.Abort  ")
            SCSI.E.Data.Out.Abort
              so.write.string.nl(fs, ts, "Data.Out.Abort ")
            SCSI.E.Unexpected.Phase.Change
              so.write.string.nl(fs, ts, "Unexpected.Phase.Change ")
            SCSI.E.Failed.Self.Test
              so.write.string.nl(fs, ts, "Failed.Self.Test  ")
            SCSI.E.Software.Error
              so.write.string.nl(fs, ts, "Software.Error ")
            SCSI.E.Not.Implemented
              so.write.string.nl(fs, ts, "Not.Implemented")
            ELSE
              SEQ
                so.write.string(fs, ts, "Unrecognised Exection Status")
                so.write.hex.int(fs, ts, (INT Execution.Status), 4)
            --}}}
          Press.Any.Key.To.Continue()
          --}}}
      TRUE
        SKIP
:
--}}}
--{{{  Display Status
PROC Display.SCSI.Status([]BYTE Message,
                         BYTE Msg.Length,
                         BYTE SCSI.Status,
                         INT16 Execution.Status)
  SEQ
    IF
      ((INT Execution.Status) <> (INT SCSI.E.Good))
        SEQ
          --{{{  Display Status
          so.write.string( fs, ts, "Status = ")
          so.write.hex.int( fs, ts, INT SCSI.Status, 2)
          IF
            Msg.Length > Zero.B
              SEQ
                so.write.string (fs, ts, " : Message : ")
                SEQ i = 0 FOR INT Msg.Length
                  so.write.hex.int ( fs, ts, INT Message[i], 2)
            TRUE
              SKIP
          IF
            Execution.Status <> SCSI.E.Good
              SEQ
                so.write.string(fs, ts, " : Execution = ")
                CASE Execution.Status
                  --{{{  Display Appropriate Message
                  SCSI.E.Good
                    so.write.string.nl(fs, ts, "Good  ")
                  SCSI.E.Bad.SCSI.Status
                    so.write.string.nl(fs, ts, "Bad.SCSI.Status")
                  SCSI.E.Command.Not.Complete
                    so.write.string.nl(fs, ts, "Command.Not.Complete ")
                  SCSI.E.Incorrect.IO.Process.Number
                    so.write.string.nl(fs, ts, "Incorrect.IO.Process.Number")
                  SCSI.E.SCSI.Bus.Parity.Error
                    so.write.string.nl(fs, ts, "SCSI.Bus.Parity.Error")
                  SCSI.E.Data.In.Failure
                    so.write.string.nl(fs, ts, "Data.In.Failure")
                  SCSI.E.Bad.Data.In.Returned.Packet.Size
                    so.write.string.nl(fs, ts, "Bad.Data.In.Returned.Packet.Size ")
                  SCSI.E.Data.Out.Failure
                    so.write.string.nl(fs, ts, "Data.Out.Failure  ")
                  SCSI.E.Bad.Data.Out.Returned.Packet.Size
                    so.write.string.nl(fs, ts, "Bad.Data.Out.Returned.Packet.Size")
                  SCSI.E.Data.In.Time.Out
                    so.write.string.nl(fs, ts, "Data.In.Time.Out  ")
                  SCSI.E.Data.Out.Time.Out
                    so.write.string.nl(fs, ts, "Data.Out.Time.Out ")
                  SCSI.E.Command.Time.Out
                    so.write.string.nl(fs, ts, "Command.Time.Out  ")
                  SCSI.E.Status.Time.Out
                    so.write.string.nl(fs, ts, "Status.Time.Out")
                  SCSI.E.Controller.Reset.Time.Out
                    so.write.string.nl(fs, ts, "Controller.Reset.Time.Out  ")
                  SCSI.E.Bus.Reset.Time.Out
                    so.write.string.nl(fs, ts, "Bus.Reset.Time.Out")
                  SCSI.E.Reselected
                    so.write.string.nl(fs, ts, "Reselected  ")
                  SCSI.E.Function.Not.Complete
                    so.write.string.nl(fs, ts, "Function.Not.Complete")
                  SCSI.E.Disconnected
                    so.write.string.nl(fs, ts, "Disconnected")
                  SCSI.E.Not.Bus.Service
                    so.write.string.nl(fs, ts, "Not.Bus.Service")
                  SCSI.E.Sequence.Not.Complete
                    so.write.string.nl(fs, ts, "Sequence.Not.Complete")
                  SCSI.E.Premature.Phase.Change
                    so.write.string.nl(fs, ts, "Premature.Phase.Change  ")
                  SCSI.E.Target.Did.Not.Assert.ATN
                    so.write.string.nl(fs, ts, "Target.Did.Not.Assert.ATN  ")
                  SCSI.E.Target.Did.Not.Assert.Message.Out
                    so.write.string.nl(fs, ts, "Target.Did.Not.Assert.Message.Out")
                  SCSI.E.Selection.Time.Out
                    so.write.string.nl(fs, ts, "Selection.Time.Out")
                  SCSI.E.Undocumented.Error
                    so.write.string.nl(fs, ts, "Undocumented.Error")
                  SCSI.E.Data.In.Abort
                    so.write.string.nl(fs, ts, "Data.In.Abort  ")
                  SCSI.E.Data.Out.Abort
                    so.write.string.nl(fs, ts, "Data.Out.Abort ")
                  SCSI.E.Unexpected.Phase.Change
                    so.write.string.nl(fs, ts, "Unexpected.Phase.Change ")
                  SCSI.E.Failed.Self.Test
                    so.write.string.nl(fs, ts, "Failed.Self.Test  ")
                  SCSI.E.Software.Error
                    so.write.string.nl(fs, ts, "Software.Error ")
                  SCSI.E.Not.Implemented
                    so.write.string.nl(fs, ts, "Not.Implemented")
                  ELSE
                    SEQ
                      so.write.string(fs, ts, "Unrecognised Exection Status")
                      so.write.hex.int(fs, ts, (INT Execution.Status), 4)
                  --}}}
          
          Press.Any.Key.To.Continue()
          --}}}
      TRUE
        SKIP
:
--}}}
--{{{  Define Test Buffer
PROC Define.Test.Buffer( []BYTE Buffer, VAL INT Size)
  INT i:
  SEQ
    i := 0
    SEQ j = 0 FOR Size
      INT Lower.Byte:
      SEQ
        Lower.Byte := (j /\ #FF)
        Buffer[j] := BYTE (Lower.Byte)
:
--}}}
--{{{  Clear Test Buffer
PROC Clear.Test.Buffer( []BYTE Buffer, VAL INT Size)
  SEQ
    --{{{
    --  VAL INT S IS (Size / (SIZE INT)):
    --  [S]INT Buf RETYPES [Buffer FROM 0 FOR (S * Size)]:
    --  SEQ
    --    IF
    --      (S > 64)
    --        [64]INT Tmp:
    --        SEQ
    --          SEQ I = 0 FOR 64
    --            Tmp[I] := 0
    --          SEQ I = 0 FOR (S / 64)
    --            [Buf FROM I FOR 64] := Tmp
    --        SEQ I = 0 FOR
    --      TRUE
    --
    --  SEQ I = 0 FOR S
    --    Buf[I] := 0
    --
    --}}}
    SEQ j = 0 FOR (Size / 512)
      SEQ i = 0 FOR 256
        SEQ
          Buffer[(j*512) + i] := 0 (BYTE)
          Buffer[(((j*512) + i) + 256)] := 0 (BYTE)
:
--}}}
--{{{  Compare Test Buffer
PROC Compare.Byte.Buffers( VAL []BYTE Buffer, VAL []BYTE Compare, INT Failures, VAL INT Size)
  VAL []INT I.Buff RETYPES Buffer:
  VAL []INT C.Buff RETYPES Compare:
  VAL INT I.Size IS (Size / Bytes.Per.INT):
  SEQ
    SEQ j = 0 FOR I.Size
      IF
        I.Buff[j] <> C.Buff[(j /\ 63)]
          --{{{  increment byte failure count
          VAL []BYTE I.Bytes RETYPES I.Buff[j]:
          VAL []BYTE C.Bytes RETYPES C.Buff[(j /\ 63)]:
          SEQ i = 0 FOR Bytes.Per.INT
            SEQ
              IF
                I.Bytes[i] <> C.Bytes[i]
                  Failures := Failures + 1
                TRUE
                  SKIP
          --}}}
        TRUE
          SKIP
:
--}}}
--{{{  Define Data Blocks
PROC Define.Data.Blocks([]BYTE  Data.Blocks,
                        []BYTE  Compare.Buff,
                        INT     Error.Count,
                        VAL INT Transfer.Size)
  SEQ
    Define.Test.Buffer(Compare.Buff, 256)
    VAL INT C.Size IS SIZE Compare.Buff:
    VAL INT Count IS (Number.of.Blocks * (Block.Size.INT / C.Size)):
    SEQ
      SEQ i = 0 FOR Count
        VAL INT Index IS (i * C.Size):
        SEQ
          [Data.Blocks FROM Index FOR C.Size] := [Compare.Buff FROM 0 FOR C.Size]
    Compare.Byte.Buffers(Data.Blocks, Compare.Buff, Error.Count, Transfer.Size)
:
--}}}
--{{{  Clear Data Blocks
PROC Define.Data.Blocks([]BYTE  Data.Blocks,
                        []BYTE  Compare.Buff,
                        INT     Error.Count,
                        VAL INT Transfer.Size)
  SEQ
    Clear.Test.Buffer(Compare.Buff, 256)
    VAL INT C.Size IS SIZE Compare.Buff:
    VAL INT Count IS (Number.of.Blocks * (Block.Size.INT / C.Size)):
    SEQ
      SEQ i = 0 FOR Count
        VAL INT Index IS (i * C.Size):
        SEQ
          [Data.Blocks FROM Index FOR C.Size] := [Compare.Buff FROM 0 FOR C.Size]
:
--}}}
