PROC Format.Options(CHAN OF SP fs, ts,
                    CHAN OF TO.SCSI tscsi,
                    CHAN OF FROM.SCSI fscsi)
  BOOL Going:
  INT  reply:
  SEQ
    Going := TRUE
    WHILE Going
      SEQ
        --{{{  Prompt User
        Display.Options(fs, ts,
                        Main.Title,
                        "Format Options (Chapter 8)",
                        ["Exit           ",
                         "Define Bus ID  ",
                         "Request Sense  ",
                         "Basic Format   ",
                         "Detailed Format"],
                         Status.Message,
                         reply)
        --}}}  
        --{{{  Do User request
        CASE reply
          0
            Going := FALSE
          1
            --{{{  Prompt operator for initiator and target SCSI device ID's
            BOOL First.Time:
            SEQ
              First.Time := TRUE
              Initiator.ID := 7 (BYTE)
              Target.ID := 7 (BYTE)
              WHILE (Initiator.ID = Target.ID)
                SEQ
                  IF
                    NOT First.Time
                      --{{{  Warning Message
                      so.write.string.nl(fs, ts, "Initiator ID and Target ID must be different.")
                      --}}}  
                    TRUE
                      First.Time := FALSE
                  --{{{  Prompt Operator for Initiator ID
                  INT reply:
                  SEQ
                    Quit := TRUE
                    so.ask(fs, ts,
                           "Which Initiator ID do you wish to set IMS B422 as > ",
                           "01234567",
                           TRUE,
                           TRUE,
                           reply)
                    Initiator.ID := BYTE reply
                    so.write.nl(fs, ts)
                    so.write.nl(fs, ts)
                  --}}}  
                  --{{{  Prompt Operator for Target ID
                  INT reply:
                  SEQ
                    Quit := TRUE
                    so.ask(fs, ts,
                           "Which Target ID do you wish IMS B422 to talk to   > ",
                           "01234567",
                           TRUE,
                           TRUE,
                           reply)
                    Target.ID := BYTE reply
                    so.write.nl(fs, ts)
                    so.write.nl(fs, ts)
                  --}}}  
              --{{{  Make IMS B422 an Initiator
              so.write.string.nl(fs, ts, "Make B422 an Initiator")
              Enable.Initiator.Mode( tscsi,
                                     fscsi,
                                     BYTE Initiator.ID,
                                     Execution.Status)
              --}}}  
              Prepare.Status.Message(Execution.Status, Status.Message)
            --}}}  
          2
            --{{{  Request Sense
            Request.Sense(fs, ts, tscsi, fscsi)
            --}}}  
          3
            --{{{  Format Drive
            SEQ
              Set.Identify.Message()
              Display.Under.Scored.Line(fs, ts, "Format Disk",'=')
              Blank.Line(fs, ts, 3)
              so.ask(fs, ts,
                     "Formatting will destroy all data stored on this device. Continue ",
                     "YN",
                     TRUE,
                     TRUE,
                     reply)
            
              so.write.nl(fs, ts)
              IF
                (reply = 0)
                  SEQ
                    --{{{  Format Disk
                    so.ask(fs, ts, "Interleave Factor [1..9]",
                                   "123456789",
                                   TRUE,
                                   TRUE,
                                   reply)
                    
                    so.write.nl(fs, ts)
                    
                    CHAN OF BOOL formatter:
                    PAR
                      --{{{  rotating cursor to captivate audience
                      BOOL formatting:
                      INT Compass.Direction:
                      INT Delay :
                      SEQ
                        formatting := TRUE
                        Compass.Direction := 0
                        Delay := 1000
                        WHILE formatting
                          SEQ
                            Activity.Monitor(fs, ts,
                                         Compass.Direction,
                                         Delay)
                            ALT
                              formatter ? formatting
                                SKIP
                              TRUE & SKIP
                                SKIP
                      --}}}  
                      --{{{  format that drive !
                      SEQ
                        --{{{   Format
                        SCSI.Format.6 (tscsi,
                                       fscsi,
                                       Target.ID,
                                       LUN,
                                       Zero.B,
                                       Zero.B,
                                       4 (BYTE),
                                       Zero.B,
                                       INT32 reply,
                                       Non.Linked.Command,
                                       0 (INT32),
                                       Null.Buff,
                                       Msg.Length,
                                       Message,
                                       SCSI.Status,
                                       Execution.Status)
                        --}}}  
                        formatter ! FALSE
                      --}}}  
                    Prepare.Status.Message(Execution.Status, Status.Message)
                    --}}}  
                TRUE
                  SKIP
            --}}}  
          4
            Not.Implemented(fs, ts)
          ELSE
            so.write.string.nl(fs, ts, "Not Implemented")
        --}}}  
:
