--{{{  Header
#COMMENT "Copyright INMOS Limited 1990, 1991"
#COMMENT "IMS F002C Product release SCSI software libraries"
--------------------------------------------------------------------------------
--
-- Date        : 04-Apr-1990
--
-- File Name   : REQSENS.INC
--
-- Project     : F002 - SCSI Tram Software
--
-- Version     : 1.0
--
-- Division    : IQ Systems
--
-- Limitations : This software may be distributed in source form.
--
-- Description : Calls request Sense Command
--
--------------------------------------------------------------------------------
-- Schedule of Amendments
--------------------------------------------------------------------------------
--
--------------------------------------------------------------------------------
--}}}  
--{{{  implementation
PROC Request.Sense(CHAN OF SP fs, ts,
                   CHAN OF TO.SCSI   tscsi,
                   CHAN OF FROM.SCSI fscsi)
  SEQ
    SEQ i = 0 FOR Request.Sense.Allocation.Length
      Request.Sense.Data[i] := Zero.B
    so.write.string.nl(fs, ts, "Requesting Sense")
    Set.Identify.Message()
    SCSI.Request.Sense.6( tscsi,
                          fscsi,
                          Target.ID,
                          LUN,
                          BYTE Request.Sense.Allocation.Length,
                          Non.Linked.Command,
                          Request.Sense.Data,
                          Msg.Length,
                          Message,
                          SCSI.Status,
                          Execution.Status)

    Display.SCSI.Status(fs, ts,
                        Message,
                        Msg.Length,
                        SCSI.Status,
                        Execution.Status)

    Display.Request.Sense.Data( fs, ts, Request.Sense.Data )

    Prepare.Status.Message(Execution.Status, Status.Message)
    Press.Any.Key.To.Continue(fs, ts)
:
--}}}  
