/*{{{  Header*/
/*#COMMENT "Copyright INMOS Limited 1990, 1991, 1992" */
/*#COMMENT "IMS F002C Product release SCSI Software libraries" */
/*------------------------------------------------------------------------------ */
/* */
/* Date        : 10_December_1991 */
/* */
/* File Name   : i_dirtac.h */
/* */
/* Project     : F002 - SCSI Tram Software */
/* */
/* Version     : 1.3 */
/* */
/* Division    : IQ Systems */
/* */
/* Limitations : This software may be distributed in source form. */
/* */
/* Description : SCSI Direct Access Mode interfaces to I_DIRTAC.LIB       */
/* */
/*-------------------------------------------------------------------------- */
/* Schedule of Amendments */
/*-------------------------------------------------------------------------- */
/* 10/12/91 - PF Removed Wrappers to call occam indirectly                   */
/*-------------------------------------------------------------------------- */
/*}}}  */
#include <channel.h>
/*{{{  Build Commands*/
/*{{{  SCSI_Build_Format_6*/
#pragma IMS_translate ( SCSI_Build_Format_6,"SCSI.Build.Format.6")

 void SCSI_Build_Format_6 ( const char     lun,
                            const char     fmtdata,
                            const char     cmplst,
                            const char     defect_list_format,
                            const char     vendor_specific,
                            const long int interleave,
                            const char     control_byte,
                            char          *scsi_command_length,
                            char           scsi_command[],
                            int            scsi_command_size,
                            char          *data_transfer );

#pragma IMS_nolink (SCSI_Build_Format_6 )
/*}}}  */
/*{{{  SCSI_Build_Read_6*/
#pragma IMS_translate ( SCSI_Build_Read_6 ,"SCSI.Build.Read.6")

 void SCSI_Build_Read_6 ( const char     lun,
                          const long int logical_block_address,
                          const char     transfer_count,
                          const char     control_byte,
                          char          *scsi_command_length,
                          char           scsi_command[],
                          int            scsi_command_size,
                          char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Read_6 )
/*}}}  */
/*{{{  SCSI_Build_Read_10*/
#pragma IMS_translate ( SCSI_Build_Read_10 ,"SCSI.Build.Read.10")

 void SCSI_Build_Read_10 ( const char     lun,
                           const char     dpo,
                           const char     fua,
                           const char     reserved_1,
                           const char     reladr,
                           const long int logical_block_address,
                           const char     reserved_6,
                           const long int transfer_count,
                           const char     control_byte,
                           char          *scsi_command_length,
                           char           scsi_command[],
                           int            scsi_command_size,
                           char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Read_10 )
/*}}}  */
/*{{{  SCSI_Build_Read_Capacity_10*/
#pragma IMS_translate ( SCSI_Build_Read_Capacity_10 ,"SCSI.Build.Read.Capacity.10")

 void SCSI_Build_Read_Capacity_10 ( const char     lun,
                                    const char     reserved_0,
                                    const char     reladr,
                                    const long int logical_block_address,
                                    const char     reserved_6,
                                    const char     reserved_7,
                                    const char     reserved_8,
                                    const char     pmi,
                                    const char     control_byte,
                                    char          *scsi_command_length,
                                    char           scsi_command[],
                                    int            scsi_command_size,
                                    char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Read_Capacity_10 )
/*}}}  */
/*{{{  SCSI_Build_Read_Defect_Data_10*/
#pragma IMS_translate ( SCSI_Build_Read_Defect_Data_10 ,"SCSI.Build.Read.Defect.Data.10")

 void SCSI_Build_Read_Defect_Data_10 ( const char     lun,
                                       const char     defect_list_Format,
                                       const char     growing_list,
                                       const char     primary_list,
                                       const char     reserved_2_5,
                                       const char     reserved_3,
                                       const char     reserved_4,
                                       const char     reserved_5,
                                       const char     reserved_6,
                                       const long int allocation_length,
                                       const char     control_byte,
                                       char          *scsi_command_length,
                                       char           scsi_command[],
                                       int            scsi_command_size,
                                       char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Read_Defect_Data_10 )
/*}}}  */
/*{{{  SCSI_Build_Read_Long_10*/
#pragma IMS_translate ( SCSI_Build_Read_Long_10 ,"SCSI.Build.Read.Long.10")

 void SCSI_Build_Read_Long_10 ( const char     lun,
                                const char     reladr,
                                const char     corrct,
                                const char     reserved_1_2,
                                const int      logical_block_address,
                                const char     reserved_6,
                                const long int byte_transfer_length,
                                const char     control_byte,
                                char          *scsi_command_length,
                                char           scsi_command[],
                                int            scsi_command_size,
                                char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Read_Long_10 )
/*}}}  */
/*{{{  SCSI_Build_Reassign_Blocks_6*/
#pragma IMS_translate ( SCSI_Build_Reassign_Blocks_6 ,"SCSI.Build.Reassign.Blocks.6")

 void SCSI_Build_Reassign_Blocks_6 ( const char   lun,
                                     const char   reserved_0,
                                     const char   reserved_1,
                                     const char   reserved_2,
                                     const char   reserved_3,
                                     const char   control_byte,
                                     char        *scsi_command_length,
                                     char         scsi_command[],
                                     int          scsi_command_size,
                                     char        *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Reassign_Blocks_6 )
/*}}}  */
/*{{{  SCSI_Build_Release_6*/
#pragma IMS_translate ( SCSI_Build_Release_6 ,"SCSI.Build.Release.6")

 void SCSI_Build_Release_6 ( const char   lun,
                             const char   third_party,
                             const char   third_party_device_id,
                             const char   extent,
                             const char   reservation_id,
                             const char   reserved_3,
                             const char   reserved_4,
                             const char   control_byte,
                             char        *scsi_command_length,
                             char         scsi_command[],
                             int          scsi_command_size,
                             char        *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Release_6 )
/*}}}  */
/*{{{  SCSI_Build_Reserve_6*/
#pragma IMS_translate ( SCSI_Build_Reserve_6 ,"SCSI.Build.Reserve.6")

 void SCSI_Build_Reserve_6 ( const char     lun,
                             const char     third_party,
                             const char     third_party_device_id,
                             const char     extent,
                             const char     reservation_id,
                             const long int extent_list_length,
                             const char     control_byte,
                             char          *scsi_command_length,
                             char           scsi_command[],
                             int            scsi_command_size,
                             char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Reserve_6 )
/*}}}  */
/*{{{  SCSI_Build_Rezero_Unit_6*/
#pragma IMS_translate ( SCSI_Build_Rezero_Unit_6 ,"SCSI.Build.Rezero.Unit.6")

 void SCSI_Build_Rezero_Unit_6 ( const char   lun,
                                 const char   reserved_1,
                                 const char   reserved_2,
                                 const char   reserved_3,
                                 const char   reserved_4,
                                 const char   control_byte,
                                 char        *scsi_command_length,
                                 char         scsi_command[],
                                 int          scsi_command_size,
                                 char        *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Rezero_Unit_6 )
/*}}}  */
/*{{{  SCSI_Build_Seek_6*/
#pragma IMS_translate ( SCSI_Build_Seek_6 ,"SCSI.Build.Seek.6")

 void SCSI_Build_Seek_6 (  const char     lun,
                           const long int logical_block_address,
                           const char     reserved_4,
                           const char     control_byte,           /* Not in mamual */
                           char          *scsi_command_length,
                           char           scsi_command[],
                           int            scsi_command_size,
                           char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Seek_6 )
/*}}}  */
/*{{{  SCSI_Build_Seek_10*/
#pragma IMS_translate ( SCSI_Build_Seek_10 ,"SCSI.Build.Seek.10")

 void SCSI_Build_Seek_10 ( const char     lun,
                           const char     reserved_1,
                           const long int logical_block_address,
                           const char     reserved_6,
                           const char     reserved_7,
                           const char     reserved_8,
                           const char     control_byte,
                           char          *scsi_command_length,
                           char           scsi_command[],
                           int            scsi_command_size,
                           char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Seek_10 )
/*}}}  */
/*{{{  SCSI_Build_Start_Stop_Unit_6*/
#pragma IMS_translate ( SCSI_Build_Start_Stop_Unit_6 ,"SCSI.Build.Start.Stop.Unit.6")

 void SCSI_Build_Start_Stop_Unit_6 ( const char   lun,
                                     const char   reserved_1,
                                     const char   immediate,
                                     const char   reserved_2,
                                     const char   reserved_3,
                                     const char   reserved_4,
                                     const char   start,
                                     const char   control_byte,
                                     char        *scsi_command_length,
                                     char         scsi_command[],
                                     int          scsi_command_size,
                                     char        *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Start_Stop_Unit_6 )
/*}}}  */
/*{{{  SCSI_Build_Verify_10*/
#pragma IMS_translate ( SCSI_Build_Verify_10 ,"SCSI.Build.Verify.10")

 void SCSI_Build_Verify_10 ( const char   lun,
                        const char     dpo,
                        const char     reserved_1,
                        const char     bytchk,
                        const char     reladr,
                        const long int logical_block_address,
                        const char     reserved_6,
                        const long int verification_length,
                        const char     control_byte,
                        char          *scsi_command_length,
                        char           scsi_command[],
                        int            scsi_command_size,
                        char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Verify_10 )
/*}}}  */
/*{{{  SCSI_Build_Write_6*/
#pragma IMS_translate ( SCSI_Build_Write_6 ,"SCSI.Build.Write.6")

 void SCSI_Build_Write_6 (  const char     lun,
                            const long int logical_block_address,
                            const char     transfer_count,
                            const char     control_byte,
                            char          *scsi_command_length,
                            char           scsi_command[],
                            int            scsi_command_size,
                            char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Write_6 )
/*}}}  */
/*{{{  SCSI_Build_Write_10*/
#pragma IMS_translate ( SCSI_Build_Write_10 ,"SCSI.Build.Write.10")

 void SCSI_Build_Write_10 ( const char     lun,
                            const char     dpo,
                            const char     fua,
                            const char     reserved_1,
                            const char     reladr,
                            const long int logical_block_address,
                            const char     reserved_6,
                            const long int transfer_count,
                            const char     control_byte,
                            char          *scsi_command_length,
                            char           scsi_command[],
                            int            scsi_command_size,
                            char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Write_10 )
/*}}}  */
/*{{{  SCSI_Build_Write_Long_10*/
#pragma IMS_translate ( SCSI_Build_Write_Long_10 ,"SCSI.Build.Write.Long.10")

 void SCSI_Build_Write_Long_10 ( const char     lun,
                                 const char     reladr,
                                 const char     reserved_1,
                                 const long int logical_block_address,
                                 const char     reserved_6,
                                 const long int byte_transfer_length,
                                 const char     control_byte,
                                 char          *scsi_command_length,
                                 char           scsi_command[],
                                 int            scsi_command_size,
                                 char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Write_Long_10 )
/*}}}  */
/*{{{  SCSI_Build_Write_and_Verify_10*/
#pragma IMS_translate ( SCSI_Build_Write_and_Verify_10 ,"SCSI.Build.Write.and.Verify.10")

 void SCSI_Build_Write_and_Verify_10 ( const char     lun,
                                       const char     dpo,
                                       const char     reserved_1,
                                       const char     bytchk,
                                       const char     reladr,
                                       const long int logical_block_address,
                                       const char     reserved_6,
                                       const long int transfer_count,
                                       const char     control_byte,
                                       char          *scsi_command_length,
                                       char           scsi_command[],
                                       int            scsi_command_size,
                                       char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Write_and_Verify_10 )
/*}}}  */
/*}}}  */
/*{{{  Build & Issue Commands*/
/*{{{  SCSI_Format_6*/
#pragma IMS_translate ( SCSI_Format_6 , "SCSI.Format.6" )

 void SCSI_Format_6 ( Channel       *to_scsi_ha,
                      Channel       *from_scsi_ha,
                      const char     target_id,
                      const char     lun,
                      const char     fmtdata,
                      const char     cmplst,
                      const char     defect_list_Format,
                      const char     vendor_specific,
                      const long int interleave,
                      const char     control_byte,
                      const long int defect_list_length,
                      const char     defect_list[],
                      int            defect_list_size,
                      char          *msg_length,
                      char           message[],
                      int            message_size,
                      char          *scsi_status,
                      short int     *execution_status );

#pragma IMS_nolink ( SCSI_Format_6 )
/*}}}  */
/*{{{  SCSI_Read_6*/
#pragma IMS_translate ( SCSI_Read_6 ,"SCSI.Read.6")

 void SCSI_Read_6 ( Channel       *to_scsi_ha,
                    Channel       *from_scsi_ha,
                    const char     target_id,
                    const char     lun,
                    const int      logical_block_address,
                    const char     number_of_blocks,
                    const long int block_size,
                    const char     control_byte,
                    char           rx_data[],
                    int            rx_data_size,
                    char          *msg_length,
                    char           message[],
                    int            message_size,
                    char          *scsi_status,
                    short int     *execution_status );

#pragma IMS_nolink ( SCSI_Read_6 )
/*}}}  */
/*{{{  SCSI_Read_10*/
#pragma IMS_translate ( SCSI_Read_10 , "SCSI.Read.10" )

 void SCSI_Read_10 ( Channel       *to_scsi_ha,
                     Channel       *from_scsi_ha,
                     const char     target_id,
                     const char     lun,
                     const char     dpo,
                     const char     fua,
                     const char     reladr,
                     const long int logical_block_address,
                     const long int number_of_blocks,
                     const long int block_size,
                     const char     control_byte,
                     char           rx_data[],
                     int            rx_data_size,
                     char          *msg_length,
                     char           message[],
                     int            message_size,
                     char          *scsi_status,
                     short int     *execution_status );

#pragma IMS_nolink ( SCSI_Read_10 )
/*}}}  */
/*{{{  SCSI_Read_10_DL*/
#pragma IMS_translate ( SCSI_Read_10_DL ,"SCSI.Read.10.DL")

 void SCSI_Read_10_DL ( Channel       *c_to_scsi,
                        Channel       *d_to_scsi,
                        Channel       *c_from_scsi,
                        Channel       *d_from_scsi,
                        const char     interval_offset,
                        const char     target_id,
                        const char     lun,
                        const char     dpo,
                        const char     fua,
                        const char     reladr,
                        const long int logical_block_address,
                        const long int number_of_blocks,
                        const int      block_size,
                        const char     control_byte,
                        char           rx_data[],
                        int            rx_data_size,
                        char          *msg_length,
                        char           message[],
                        int            message_size,
                        char          *scsi_status,
                        short int     *execution_status );

#pragma IMS_nolink ( SCSI_Read_10_DL )
/*}}}  */
/*{{{  SCSI_Read_Capacity_10*/
#pragma IMS_translate ( SCSI_Read_Capacity_10 ,"SCSI.Read.Capacity.10")

 void SCSI_Read_Capacity_10 (  Channel       *to_scsi_ha,
                               Channel       *from_scsi_ha,
                               const char     target_id,
                               const char     lun,
                               const char     reladr,
                               const long int logical_block_address,
                               const char     pmi,
                               const char     control_byte,
                               char           read_capacity_data[],
                               int            read_capacity_data_size,
                               char          *msg_length,
                               char           message[],
                               int            message_size,
                               char          *scsi_status,
                               short int     *execution_status );

#pragma IMS_nolink ( SCSI_Read_Capacity_10 )
/*}}}  */
/*{{{  SCSI_Read_Defect_Data_10*/
#pragma IMS_translate ( SCSI_Read_Defect_Data_10 ,"SCSI.Read.Defect.Data.10")

 void SCSI_Read_Defect_Data_10 ( Channel       *to_scsi_ha,
                                 Channel       *from_scsi_ha,
                                 const char     target_id,
                                 const char     lun,
                                 const char     defect_list_Format,
                                 const char     growing_list,
                                 const char     primary_list,
                                 const long int allocation_length,
                                 const char     control_byte,
                                 char           defect_list[],
                                 int            defect_list_size,
                                 char          *msg_length,
                                 char           message[],
                                 int            message_size,
                                 char          *scsi_status,
                                 short int     *execution_status );

#pragma IMS_nolink ( SCSI_Read_Defect_Data_10 )
/*}}}  */
/*{{{  SCSI_Read_Long_10*/
#pragma IMS_translate ( SCSI_Read_Long_10 ,"SCSI.Read.Long.10")

 void SCSI_Read_Long_10 ( Channel       *to_scsi_ha,
                          Channel       *from_scsi_ha,
                          const char     target_id,
                          const char     lun,
                          const char     reladr,
                          const char     corrct,
                          const long int logical_block_address,
                          const long int byte_transfer_length,
                          const char     control_byte,
                          char           rx_data[],
                          int            rx_data_size,
                          char          *msg_length,
                          char           message[],
                          int            message_size,
                          char          *scsi_status,
                          short int     *execution_status );

#pragma IMS_nolink ( SCSI_Read_Long_10 )
/*}}}  */
/*{{{  SCSI_Reassign_Blocks_6*/
#pragma IMS_translate ( SCSI_Reassign_Blocks_6 ,"SCSI.Reassign.Blocks.6")

 void SCSI_Reassign_Blocks_6 ( Channel       *to_scsi_ha,
                               Channel       *from_scsi_ha,
                               const char     target_id,
                               const char     lun,
                               const char     control_byte,
                               const long int defect_list_length,
                               const char     defect_list[],
                               int            defect_list_size,
                               char          *msg_length,
                               char           message[],
                               int            message_size,
                               char          *scsi_status,
                               short int     *execution_status );

#pragma IMS_nolink ( SCSI_Reassign_Blocks_6 )
/*}}}  */
/*{{{  SCSI_Release_6*/
#pragma IMS_translate ( SCSI_Release_6 ,"SCSI.Release.6")

 void SCSI_Release_6 ( Channel    *to_scsi_ha,
                       Channel    *from_scsi_ha,
                       const char  target_id,
                       const char  lun,
                       const char  third_party,
                       const char  third_party_device_id,
                       const char  extent,
                       const char  reservation_id,
                       const char  control_byte,
                       char       *msg_length,
                       char        message[],
                       int         message_size,
                       char       *scsi_status,
                       short int  *execution_status );

#pragma IMS_nolink ( SCSI_Release_6 )
/*}}}  */
/*{{{  SCSI_Reserve_6*/
#pragma IMS_translate ( SCSI_Reserve_6 ,"SCSI.Reserve.6")

 void SCSI_Reserve_6 (  Channel       *to_scsi_ha,
                        Channel       *from_scsi_ha,
                        const char     target_id,
                        const char     lun,
                        const char     third_party,
                        const char     third_party_device_id,
                        const char     extent,
                        const char     reservation_id,
                        const long int extent_list_length,
                        const char     control_byte,
                        const char     extent_list[],
                        int            extent_list_size,
                        char          *msg_length,
                        char           message[],
                        int            message_size,
                        char          *scsi_status,
                        short int     *execution_status );

#pragma IMS_nolink ( SCSI_Reserve_6 )
/*}}}  */
/*{{{  SCSI_Rezero_Unit_6*/
#pragma IMS_translate ( SCSI_Rezero_Unit_6 ,"SCSI.Rezero.Unit.6")

 void SCSI_Rezero_Unit_6 (  Channel    *to_scsi_ha,
                            Channel    *from_scsi_ha,
                            const char  target_id,
                            const char  lun,
                            const char  control_byte,
                            char       *msg_length,
                            char        message[],
                            int         message_size,
                            char       *scsi_status,
                            short int  *execution_status );

#pragma IMS_nolink ( SCSI_Rezero_Unit_6 )
/*}}}  */
/*{{{  SCSI_Seek_6*/
#pragma IMS_translate ( SCSI_Seek_6 ,"SCSI.Seek.6")

 void SCSI_Seek_6 ( Channel       *to_scsi_ha,
                    Channel       *from_scsi_ha,
                    const char     target_id,
                    const char     lun,
                    const long int logical_block_address,
                    const char     control_byte,
                    char          *msg_length,
                    char           message[],
                    int            message_size,
                    char          *scsi_status,
                    short int     *execution_status );

#pragma IMS_nolink ( SCSI_Seek_6 )
/*}}}  */
/*{{{  SCSI_Seek_10*/
#pragma IMS_translate ( SCSI_Seek_10 ,"SCSI.Seek.10")

 void SCSI_Seek_10 ( Channel       *to_scsi_ha,
                     Channel       *from_scsi_ha,
                     const char     target_id,
                     const char     lun,
                     const long int logical_block_address,
                     const char     control_byte,
                     char          *msg_length,
                     char           message[],
                     int            message_size,
                     char          *scsi_status,
                     short int     *execution_status );

#pragma IMS_nolink ( SCSI_Seek_10 )
/*}}}  */
/*{{{  SCSI_Start_Stop_Unit_6*/
#pragma IMS_translate ( SCSI_Start_Stop_Unit_6 ,"SCSI.Start.Stop.Unit.6")

 void SCSI_Start_Stop_Unit_6 ( Channel    *to_scsi_ha,
                               Channel    *from_scsi_ha,
                               const char  target_id,
                               const char  lun,
                               const char  immediate,
                               const char  start,
                               const char  control_byte,
                               char       *msg_length,
                               char        message[],
                               int         message_size,
                               char       *scsi_status,
                               short int  *execution_status );

#pragma IMS_nolink ( SCSI_Start_Stop_Unit_6 )
/*}}}  */
/*{{{  SCSI_Verify_10*/
#pragma IMS_translate ( SCSI_Verify_10 ,"SCSI.Verify.10")

 void SCSI_Verify_10 ( Channel       *to_scsi_ha,
                       Channel       *from_scsi_ha,
                       const char     target_id,
                       const char     lun,
                       const char     dpo,
                       const char     bytchk,
                       const char     reladr,
                       const long int logical_block_address,
                       const long int verification_length,
                       const long int block_size,
                       const char     control_byte,
                       const char     verification_data[],
                       int            verification_data_size,
                       char          *msg_length,
                       char           message[],
                       int            message_size,
                       char          *scsi_status,
                       short int     *execution_status );

#pragma IMS_nolink ( SCSI_Verify_10 )
/*}}}  */
/*{{{  SCSI_Write_6*/
#pragma IMS_translate ( SCSI_Write_6 ,"SCSI.Write.6")

 void SCSI_Write_6 ( Channel       *to_scsi_ha,
                     Channel       *from_scsi_ha,
                     const char     target_id,
                     const char     lun,
                     const long int logical_block_address,
                     const char     number_of_blocks,
                     const long int block_size,
                     const char     control_byte,
                     const char     tx_data[],
                     int            tx_data_size,
                     char          *msg_length,
                     char           message[],
                     int            message_size,
                     char          *scsi_status,
                     short int     *execution_status );

#pragma IMS_nolink ( SCSI_Write_6 )
/*}}}  */
/*{{{  SCSI_Write_10*/
#pragma IMS_translate ( SCSI_Write_10 ,"SCSI.Write.10")

 void SCSI_Write_10 ( Channel       *to_scsi_ha,
                      Channel       *from_scsi_ha,
                      const char     target_id,
                      const char     lun,
                      const char     dpo,
                      const char     fua,
                      const char     reladr,
                      const long int logical_block_address,
                      const long int number_of_blocks,
                      const long int block_size,
                      const char     control_byte,
                      const char     tx_data[],
                      int            tx_data_size,
                      char          *msg_length,
                      char           message[],
                      int            message_size,
                      char          *scsi_status,
                      short int     *execution_status );

#pragma IMS_nolink ( SCSI_Write_10 )
/*}}}  */
/*{{{  SCSI_Write_10_DL*/
#pragma IMS_translate ( SCSI_Write_10_DL ,"SCSI.Write.10.DL")

 void SCSI_Write_10_DL ( Channel       *c_to_scsi,
                         Channel       *d_to_scsi,
                         Channel       *c_from_scsi,
                         Channel       *d_from_scsi,
                         const char     interval_offset,
                         const char     target_id,
                         const char     lun,
                         const char     dpo,
                         const char     fua,
                         const char     reladr,
                         const long int logical_block_address,
                         const long int number_of_blocks,
                         const long int block_size,
                         const char     control_byte,
                         const char     tx_data[],
                         int            tx_data_size,
                         char          *msg_length,
                         char           message[],
                         int            message_size,
                         char          *scsi_status,
                         short int     *execution_status );

#pragma IMS_nolink ( SCSI_Write_10_DL )
/*}}}  */
/*{{{  SCSI_Write_And_Verify_10*/
#pragma IMS_translate ( SCSI_Write_And_Verify_10 ,"SCSI.Write.and.Verify.10")

 void SCSI_Write_And_Verify_10 ( Channel *to_scsi_ha,
                                 Channel *from_scsi_ha,
                                 const char     target_id,
                                 const char     lun,
                                 const char     dpo,
                                 const char     bytchk,
                                 const char     reladr,
                                 const long int logical_block_address,
                                 const long int number_of_blocks,
                                 const long int block_size,
                                 const char     control_byte,
                                 const char     tx_data[],
                                 int            tx_data_size,
                                 char          *msg_length,
                                 char           message[],
                                 int            message_size,
                                 char          *scsi_status,
                                 short int     *execution_status );

#pragma IMS_nolink ( SCSI_Write_And_Verify_10 )
/*}}}  */
/*{{{  SCSI_Write_Long_10*/
#pragma IMS_translate ( SCSI_Write_Long_10 ,"SCSI.Write.Long.10")

 void SCSI_Write_Long_10 ( Channel       *to_scsi_ha,
                           Channel       *from_scsi_ha,
                           const char     target_id,
                           const char     lun,
                           const char     reladr,
                           const long int logical_block_address,
                           const long int byte_transfer_length,
                           const char     control_byte,
                           const char     tx_data[],
                           int            tx_data_size,
                           char          *msg_length,
                           char           message[],
                           int            message_size,
                           char          *scsi_status,
                           short int     *execution_status );

#pragma IMS_nolink ( SCSI_Write_Long_10 )
/*}}}  */
/*}}}  */
