/*{{{  Header*/
/*#COMMENT "Copyright INMOS Limited 1990, 1991, 1992" */
/*#COMMENT "IMS F002C Product release SCSI Software libraries" */
/*------------------------------------------------------------------------------ */
/* */
/* Date        : 10_December_1991 */
/* */
/* File Name   : i_seqacc.h */
/* */
/* Project     : F002 - SCSI Tram Software */
/* */
/* Version     : 1.3 */
/* */
/* Division    : IQ Systems */
/* */
/* Limitations : This software may be distributed in source form. */
/* */
/* Description : SCSI Sequential Access mode interfaces to I_SEQACC.LIB       */
/* */
/*-------------------------------------------------------------------------- */
/* Schedule of Amendments */
/*-------------------------------------------------------------------------- */
/* 10/12/91 - PF Removed Wrappers to call occam indirectly                   */
/*-------------------------------------------------------------------------- */
/*}}}  */
#include <channel.h>
/*{{{  Build commands*/
/*{{{  SCSI_Build_SA_Erase_6 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Erase_6 ,"SCSI.Build.SA.Erase.6")

void SCSI_Build_SA_Erase_6 ( const char  lun,
                             const char  reserved_1,
                             const char  immediate,
                             const char  Long,
                             const char  reserved_2,
                             const char  reserved_3,
                             const char  reserved_4,
                             const char  control_byte,
                             char       *scsi_command_length,
                             char        scsi_command[],
                             int         scsi_command_size,
                             char       *data_transfer);

#pragma IMS_nolink ( SCSI_Build_SA_Erase_6 )
/*}}}  */
/*{{{  SCSI_Build_SA_Load_Unload_6 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Load_Unload_6, "SCSI.Build.SA.Load.Unload.6")

void SCSI_Build_SA_Load_Unload_6 ( const char  lun,
                                   const char  reserved_1,
                                   const char  immediate,
                                   const char  reserved_2,
                                   const char  reserved_3,
                                   const char  reserved_4,
                                   const char  eot,
                                   const char  re_ten,
                                   const char  load,
                                   const char  control_byte,
                                   char       *scsi_command_length,
                                   char        scsi_command[],
                                   int         scsi_command_size,
                                   char       *data_transfer);
#pragma IMS_nolink ( SCSI_Build_SA_Load_Unload_6 )
/*}}}  */
/*{{{  SCSI_Build_SA_Locate_10 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Locate_10, "SCSI.Build.SA.Locate.10")

void SCSI_Build_SA_Locate_10(  const char     lun,
                               const char     reserved_1,
                               const char     bt,
                               const char     cp,
                               const char     immediate,
                               const char     reserved_2,
                               const long int block_address,
                               const char     reserved_3,
                               const char     partition,
                               const char     control_byte,
                               char          *scsi_command_length,
                               char           scsi_command[],
                               int            scsi_command_size,
                               char          *data_transfer);

#pragma IMS_nolink ( SCSI_Build_SA_Locate_10 )
/*}}}  */
/*{{{  SCSI_Build_SA_Read_6 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Read_6 ,"SCSI.Build.SA.Read.6")

void SCSI_Build_SA_Read_6 ( const char     lun,
                            const char     reserved_1,
                            const char     sili,
                            const char     fixed,
                            const long int transfer_length,
                            const char     control_byte,
                            char          *scsi_command_length,
                            char           scsi_command[],
                            int            scsi_command_size,
                            char          *data_transfer);

#pragma IMS_nolink ( SCSI_Build_SA_Read_6 )
/*}}}  */
/*{{{  SCSI_Build_SA_Read_Block_Limits_6 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Read_Block_Limits_6 , "SCSI.Build.SA.Read.Block.Limits.6")

void SCSI_Build_SA_Read_Block_Limits_6 ( const char  lun,
                                         const char  reserved_1,
                                         const char  reserved_2,
                                         const char  reserved_3,
                                         const char  reserved_4,
                                         const char  control_byte,
                                         char       *scsi_command_length,
                                         char        scsi_command[],
                                         int         scsi_command_size,
                                         char       *data_transfer);

#pragma IMS_nolink ( SCSI_Build_SA_Read_Block_Limits_6 )
/*}}}  */
/*{{{  SCSI_Build_SA_Read_Position_10 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Read_Position_10 , "SCSI.Build.SA.Read.Position.10")

void SCSI_Build_SA_Read_Position_10 ( const char     lun,
                                      const char     reserved_1,
                                      const char     bt,
                                      const char     reserved_2,
                                      const char     reserved_3,
                                      const char     reserved_4,
                                      const char     reserved_5,
                                      const char     reserved_6,
                                      const char     reserved_7,
                                      const char     reserved_8,
                                      const char     control_byte,
                                      char          *scsi_command_length,
                                      char           scsi_command[],
                                      int            scsi_command_size,
                                      char          *data_transfer);

#pragma IMS_nolink ( SCSI_Build_SA_Read_Position_10 )
/*}}}  */
/*{{{  SCSI_Build_SA_Read_Reverse_6 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Read_Reverse_6 , "SCSI.Build.SA.Read.Reverse.6")

void SCSI_Build_SA_Read_Reverse_6 ( const char     lun,
                                    const char     reserved_1,
                                    const char     sili,
                                    const char     fixed,
                                    const long int transfer_length,
                                    const char     control_byte,
                                    char          *scsi_command_length,
                                    char           scsi_command[],
                                    int            scsi_command_size,
                                    char          *data_transfer);

#pragma IMS_nolink ( SCSI_Build_SA_Read_Reverse_6 )
/*}}}  */
/*{{{  SCSI_Build_SA_Recover_Buffered_Data_6 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Recover_Buffered_Data_6 , "SCSI.Build.SA.Recover.Buffered.Data.6")

void SCSI_Build_SA_Recover_Buffered_Data_6 ( const char     lun,
                                             const char     reserved_1,
                                             const char     sili,
                                             const char     fixed,
                                             const long int transfer_length,
                                             const char     control_byte,
                                             char          *scsi_command_length,
                                             char           scsi_command[],
                                             int            scsi_command_size,
                                             char          *data_transfer);

#pragma IMS_nolink ( SCSI_Build_SA_Recover_Buffered_Data_6 )
/*}}}  */
/*{{{  SCSI_Build_SA_Release_6 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Release_6 , "SCSI.Build.SA.Release.6")

void SCSI_Build_SA_Release_6 ( const char  lun,
                               const char  third_party,
                               const char  third_party_device_id,
                               const char  reserved_1,
                               const char  reserved_2,
                               const char  reserved_3,
                               const char  reserved_4,
                               const char  control_byte,
                               char       *scsi_command_length,
                               char        scsi_command[],
                               int         scsi_command_size,
                               char       *data_transfer);

#pragma IMS_nolink ( SCSI_Build_SA_Release_6 )
/*}}}  */
/*{{{  SCSI_Build_SA_reserve_6 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Reserve_6 , "SCSI.Build.SA.Reserve.6")

void SCSI_Build_SA_Reserve_6 ( const char  lun,
                               const char  third_party,
                               const char  third_party_device_id,
                               const char  reserved_1,
                               const char  reserved_2,
                               const char  reserved_3,
                               const char  reserved_4,
                               const char  control_byte,
                               char       *scsi_command_length,
                               char        scsi_command[],
                               int         scsi_command_size,
                               char       *data_transfer);

#pragma IMS_nolink ( SCSI_Build_SA_Reserve_6 )
/*}}}  */
/*{{{  SCSI_Build_SA_Rewind_6 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Rewind_6 , "SCSI.Build.SA.Rewind.6")

void SCSI_Build_SA_Rewind_6 ( const char  lun,
                              const char  reserved_1,
                              const char  immediate,
                              const char  reserved_2,
                              const char  reserved_3,
                              const char  reserved_4,
                              const char  control_byte,
                              char       *scsi_command_length,
                              char        scsi_command[],
                              int         scsi_command_size,
                              char       *data_transfer);

#pragma IMS_nolink ( SCSI_Build_SA_Rewind_6 )
/*}}}  */
/*{{{  SCSI_Build_SA_Space_6 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Space_6 , "SCSI.Build.SA.Space.6")

void SCSI_Build_SA_Space_6 ( const char     lun,
                             const char     reserved_1,
                             const char     code,
                             const long int count,
                             const char     control_byte,
                             char          *scsi_command_length,
                             char           scsi_command[],
                             int            scsi_command_size,
                             char          *data_transfer);

#pragma IMS_nolink ( SCSI_Build_SA_Space_6 )
/*}}}  */
/*{{{  SCSI_Build_SA_Verify_6 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Verify_6 ,"SCSI.Build.SA.Verify.6")

void SCSI_Build_SA_Verify_6 ( const char     lun,
                              const char     reserved_1,
                              const char     immediate,
                              const char     bytcmp,
                              const char     fixed,
                              const long int verification_Length,
                              const char     control_byte,
                              char          *scsi_command_length,
                              char           scsi_command[],
                              int            scsi_command_size,
                              char          *data_transfer);

#pragma IMS_nolink ( SCSI_Build_SA_Verify_6 )
/*}}}  */
/*{{{  SCSI_Build_SA_Write_6 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Write_6 ,"SCSI.Build.SA.Write.6")

void SCSI_Build_SA_Write_6 ( const char     lun,
                             const char     fixed,
                             const long int transfer_length,
                             const char     control_byte,
                             char          *scsi_command_length,
                             char           scsi_command[],
                             int            scsi_command_size,
                             char          *data_transfer);

#pragma IMS_nolink ( SCSI_Build_SA_Write_6 )
/*}}}  */
/*{{{  SCSI_Build_SA_Write_Filemarks_6 ( ... )*/
#pragma IMS_translate ( SCSI_Build_SA_Write_Filemarks_6 ,"SCSI.Build.SA.Write.Filemarks.6")

void SCSI_Build_SA_Write_Filemarks_6 ( const char     lun,
                                       const char     reserved_1,
                                       const char     wsmk,
                                       const char     immediate,
                                       const long int transfer_length,
                                       const char     control_byte,
                                       char          *scsi_command_length,
                                       char           scsi_command[],
                                       int            scsi_command_size,
                                       char          *data_transfer);

#pragma IMS_nolink ( SCSI_Build_SA_Write_Filemarks_6 )
/*}}}  */
/*}}}  */
/*{{{  Build & issue commands*/
/*{{{  SCSI_SA_Erase_6*/
#pragma IMS_translate ( SCSI_SA_Erase_6 , "SCSI.SA.Erase.6" )

void SCSI_SA_Erase_6 ( Channel               *to_scsi_ha,
                       Channel               *from_scsi_ha,
                       const char             target_id,
                       const char             lun,
                       const char             immediate,
                       const char             Long,
                       const char             control_byte,
                       char                  *msg_Length,
                       char                   message[],
                       int                    message_size,
                       char                  *scsi_status,
                       short int             *execution_status);

#pragma IMS_nolink ( SCSI_SA_Erase_6 )
/*}}}  */
/*{{{  SCSI_SA_Load_Unload_6*/
#pragma IMS_translate ( SCSI_SA_Load_Unload_6 , "SCSI.SA.Load.Unload.6" )

void SCSI_SA_Load_Unload_6 ( Channel    *to_scsi_ha,
                             Channel    *from_scsi_ha,
                             const char  target_id,
                             const char  lun,
                             const char  immediate,
                             const char  eot,
                             const char  re_ten,
                             const char  Load,
                             const char  control_byte,
                             char       *msg_Length,
                             char        message[],
                             int         message_size,
                             char       *scsi_status,
                             short int  *execution_status);

#pragma IMS_nolink ( SCSI_SA_Load_Unload_6 )
/*}}}  */
/*{{{  SCSI_SA_Locate_10*/
#pragma IMS_translate ( SCSI_SA_Locate_10 , "SCSI.SA.Locate.10" )

void SCSI_SA_Locate_10 ( Channel               *to_scsi_ha,
                         Channel               *from_scsi_ha,
                         const char             target_id,
                         const char             lun,
                         const char             bt,
                         const char             cp,
                         const char             immediate,
                         const long int         block_address,
                         const char             partition,
                         const char             control_byte,
                         char                  *msg_Length,
                         char                   message[],
                         int                    message_size,
                         char                  *scsi_status,
                         short int             *execution_status);

#pragma IMS_nolink ( SCSI_SA_Locate_10 )
/*}}}  */
/*{{{  SCSI_SA_Read_6*/
#pragma IMS_translate ( SCSI_SA_Read_6 , "SCSI.SA.Read.6" )

void SCSI_SA_Read_6 ( Channel        *to_scsi_ha,
                      Channel        *from_scsi_ha,
                      const char      target_id,
                      const char      lun,
                      const char      sili,
                      const char      fixed,
                      const long int  transfer_length,
                      const long int  block_size,
                      const char      control_byte,
                      char            rx_data[],
                      int             rx_data_size,
                      char           *msg_length,
                      char            message[],
                      int             message_size,
                      char           *scsi_status,
                      short int      *execution_status);

#pragma IMS_nolink ( SCSI_SA_Read_6 )
/*}}}  */
/*{{{  SCSI_SA_Read_Block_Limits_6*/
#pragma IMS_translate ( SCSI_SA_Read_Block_Limits_6 , "SCSI.SA.Read.Block.Limits.6" )

void SCSI_SA_Read_Block_Limits_6 ( Channel        *to_scsi_ha,
                                   Channel        *from_scsi_ha,
                                   const char      target_id,
                                   const char      lun,
                                   const char      control_byte,
                                   char            rbl_data[],
                                   int             rbl_data_size,
                                   char           *msg_length,
                                   char            message[],
                                   int             message_size,
                                   char           *scsi_status,
                                   short int      *execution_status);

#pragma IMS_nolink ( SCSI_SA_Read_Block_Limits_6 )

/*}}}  */
/*{{{  SCSI_SA_Read_Position_10*/
#pragma IMS_translate ( SCSI_SA_Read_Position_10 , "SCSI.SA.Read.Position.10" )

void SCSI_SA_Read_Position_10 ( Channel               *to_scsi_ha,
                                Channel               *from_scsi_ha,
                                const char             target_id,
                                const char             lun,
                                const char             bt,
                                const char             control_byte,
                                char                   position_data[],
                                int                    position_data_size,
                                char                  *msg_Length,
                                char                   message[],
                                int                    message_size,
                                char                  *scsi_status,
                                short int             *execution_status);

#pragma IMS_nolink ( SCSI_SA_Read_Position_10 )
/*}}}  */
/*{{{  SCSI_SA_Read_Reverse_6*/
#pragma IMS_translate ( SCSI_SA_Read_Reverse_6 , "SCSI.SA.Read.Reverse.6" )

void SCSI_SA_Read_Reverse_6 ( Channel        *to_scsi_ha,
                              Channel        *from_scsi_ha,
                              const char      target_id,
                              const char      lun,
                              const char      sili,
                              const char      fixed,
                              const long int  transfer_length,
                              const long int  block_size,
                              const char      control_byte,
                              char            rx_data[],
                              int             rx_data_size,
                              char           *msg_length,
                              char            message[],
                              int             message_size,
                              char           *scsi_status,
                              short int      *execution_status);

#pragma IMS_nolink ( SCSI_SA_Read_Reverse_6 )
/*}}}  */
/*{{{  SCSI_SA_Recover_Buffered_Data_6*/
#pragma IMS_translate ( SCSI_SA_Recover_Buffered_Data_6 , "SCSI.SA.Recover.Buffered.Data.6" )

void SCSI_SA_Recover_Buffered_Data_6 ( Channel        *to_scsi_ha,
                                       Channel        *from_scsi_ha,
                                       const char      target_id,
                                       const char      lun,
                                       const char      sili,
                                       const char      fixed,
                                       const long int  transfer_length,
                                       const long int  block_size,
                                       const char      control_byte,
                                       char            rx_data[],
                                       int             rx_data_size,
                                       char           *msg_Length,
                                       char            message[],
                                       int             message_size,
                                       char           *scsi_status,
                                       short int      *execution_status);

#pragma IMS_nolink ( SCSI_SA_Recover_Buffered_Data_6 )
/*}}}  */
/*{{{  SCSI_SA_Release_6*/
#pragma IMS_translate ( SCSI_SA_Release_6 , "SCSI.SA.Release.6" )

void SCSI_SA_Release_6 ( Channel     *to_scsi_ha,
                         Channel     *from_scsi_ha,
                         const char   target_id,
                         const char   lun,
                         const char   third_party,
                         const char   third_party_device_id,
                         const char   control_byte,
                         char        *msg_length,
                         char         message[],
                         int          message_size,
                         char        *scsi_status,
                         short int   *execution_status);

#pragma IMS_nolink ( SCSI_SA_Release_6 )
/*}}}  */
/*{{{  SCSI_SA_Reserve_6*/
#pragma IMS_translate ( SCSI_SA_Reserve_6 , "SCSI.SA.Reserve.6" )

void SCSI_SA_Reserve_6 ( Channel    *to_scsi_ha,
                         Channel    *from_scsi_ha,
                         const char  target_Id,
                         const char  lun,
                         const char  third_Party,
                         const char  third_Party_Device_Id,
                         const char  control_Byte,
                         char       *msg_length,
                         char        message[],
                         int         message_size,
                         char       *scsi_status,
                         short int  *execution_status);

#pragma IMS_nolink ( SCSI_SA_Reserve_6 )
/*}}}  */
/*{{{  SCSI_SA_Rewind_6*/
#pragma IMS_translate ( SCSI_SA_Rewind_6 , "SCSI.SA.Rewind.6" )
void SCSI_SA_Rewind_6 ( Channel    *to_scsi_ha,
                        Channel    *from_scsi_ha,
                        const char  target_id,
                        const char  lun,
                        const char  immediate,
                        const char  control_byte,
                        char       *msg_length,
                        char        message[],
                        int         message_size,
                        char       *scsi_status,
                        short int  *execution_status);
#pragma IMS_nolink ( SCSI_SA_Rewind_6 )
/*}}}  */
/*{{{  SCSI_SA_Space_6*/
#pragma IMS_translate ( SCSI_SA_Space_6 , "SCSI.SA.Space.6" )
void SCSI_SA_Space_6 ( Channel        *to_scsi_ha,
                       Channel        *from_scsi_ha,
                       const char      target_id,
                       const char      lun,
                       const char      code,
                       const long int  count,
                       const char      control_byte,
                       char           *msg_length,
                       char            message[],
                       int             message_size,
                       char           *scsi_status,
                       short int      *execution_status);
#pragma IMS_nolink ( SCSI_SA_Space_6 )
/*}}}  */
/*{{{  SCSI_SA_Verify_6*/
#pragma IMS_translate ( SCSI_SA_Verify_6 , "SCSI.SA.Verify.6" )

void SCSI_SA_Verify_6 ( Channel        *to_scsi_ha,
                        Channel        *from_scsi_ha,
                        const char      target_id,
                        const char      lun,
                        const char      immediate,
                        const char      bytcmp,
                        const char      fixed,
                        const long int  verification_length,
                        const long int  block_size,
                        const char      control_byte,
                        const char      tx_data[],
                        int             tx_data_size,
                        char           *msg_length,
                        char            message[],
                        int             message_size,
                        char           *scsi_status,
                        short int      *execution_status);

#pragma IMS_nolink ( SCSI_SA_Verify_6 )
/*}}}  */
/*{{{  SCSI_SA_Write_6*/
#pragma IMS_translate ( SCSI_SA_Write_6 , "SCSI.SA.Write.6" )

void SCSI_SA_Write_6  ( Channel        *to_scsi_ha,
                        Channel        *from_scsi_ha,
                        const char      target_id,
                        const char      lun,
                        const char      fixed,
                        const long int  transfer_length,
                        const long int  block_size,
                        const char      control_byte,
                        const char      tx_data[],
                        int             tx_data_size,
                        char           *msg_length,
                        char            message[],
                        int             message_size,
                        char           *scsi_status,
                        short int      *execution_status);

#pragma IMS_nolink ( SCSI_SA_Write_6 )
/*}}}  */
/*{{{  SCSI_SA_Write_Filemarks_6*/
#pragma IMS_translate ( SCSI_SA_Write_Filemarks_6 , "SCSI.SA.Write.Filemarks.6" )

void SCSI_SA_Write_Filemarks_6 ( Channel        *to_scsi_ha,
                                 Channel        *from_scsi_ha,
                                 const char      target_id,
                                 const char      lun,
                                 const long int  number_of_filemarks,
                                 const char      Short,
                                 const char      control_byte,
                                 char           *msg_length,
                                 char            message[],
                                 int             message_size,
                                 char           *scsi_status,
                                 short int      *execution_status);

#pragma IMS_nolink ( SCSI_SA_Write_Filemarks_6 )
/*}}}  */
/*}}}  */
