--{{{  Header
#COMMENT "Copyright INMOS Limited 1990, 1991, 1992"
#COMMENT "IMS F002C Product release SCSI software libraries"
--------------------------------------------------------------------------------
--
-- Date        : 04-Apr-1990
--
-- File Name   : SCSICMND.INC
--
-- Project     : F002 - SCSI Tram Software
--
-- Version     : 1.0
--
-- Division    : IQ Systems
--
-- Limitations : This software may be distributed in source form.
--
-- Description : Definition of SCSI-2 Operation Codes as defined in SCSI-2
--               Working Draft Proposal Revision 8.
--
--------------------------------------------------------------------------------
-- Schedule of Amendments
--------------------------------------------------------------------------------
--
--------------------------------------------------------------------------------
--}}}  
--{{{  6  Byte Commands
VAL BYTE Test.Unit.Ready.6                 IS #00 ( BYTE ):
VAL BYTE Rewind.6                          IS #01 ( BYTE ):
VAL BYTE Rezero.Unit.6                     IS #01 ( BYTE ):
VAL BYTE Request.Sense.6                   IS #03 ( BYTE ):
VAL BYTE Format.6                          IS #04 ( BYTE ):
VAL BYTE Format.Unit.6                     IS #04 ( BYTE ):
VAL BYTE Read.Block.Limits.6               IS #05 ( BYTE ):
VAL BYTE Initialize.Element.Status.6       IS #07 ( BYTE ):
VAL BYTE Initialise.Element.Status.6       IS #07 ( BYTE ):--This side of pond!
VAL BYTE Reassign.Blocks.6                 IS #07 ( BYTE ):
VAL BYTE Get.Message.6                     IS #08 ( BYTE ):
VAL BYTE Read.6                            IS #08 ( BYTE ):
VAL BYTE Receive.6                         IS #08 ( BYTE ):
VAL BYTE Print.6                           IS #0A ( BYTE ):
VAL BYTE Send.6                            IS #0A ( BYTE ):
VAL BYTE Send.Message.6                    IS #0A ( BYTE ):
VAL BYTE Write.6                           IS #0A ( BYTE ):
VAL BYTE Seek.6                            IS #0B ( BYTE ):
VAL BYTE Slew.and.Print.6                  IS #0B ( BYTE ):
VAL BYTE Read.Reverse.6                    IS #0F ( BYTE ):
VAL BYTE Synchronize.Buffer.6              IS #10 ( BYTE ):
VAL BYTE Write.Filemarks.6                 IS #10 ( BYTE ):
VAL BYTE Write.Filemark.6                  IS #10 ( BYTE ):
VAL BYTE Space.6                           IS #11 ( BYTE ):
VAL BYTE Inquiry.6                         IS #12 ( BYTE ):
VAL BYTE Verify.6                          IS #13 ( BYTE ):
VAL BYTE Recover.Buffered.Data.6           IS #14 ( BYTE ):
VAL BYTE Mode.Select.6                     IS #15 ( BYTE ):
VAL BYTE Reserve.6                         IS #16 ( BYTE ):
VAL BYTE Reserve.Unit.6                    IS #16 ( BYTE ):
VAL BYTE Release.6                         IS #17 ( BYTE ):
VAL BYTE Release.Unit.6                    IS #17 ( BYTE ):
VAL BYTE Copy.6                            IS #18 ( BYTE ):
VAL BYTE Erase.6                           IS #19 ( BYTE ):
VAL BYTE Mode.Sense.6                      IS #1A ( BYTE ):
VAL BYTE Load.Unload.6                     IS #1B ( BYTE ):
VAL BYTE Scan.6                            IS #1B ( BYTE ):
VAL BYTE Stop.Print.6                      IS #1B ( BYTE ):
VAL BYTE Start.Stop.Unit.6                 IS #1B ( BYTE ):
VAL BYTE Receive.Diagnostic.Results.6      IS #1C ( BYTE ):
VAL BYTE Send.Diagnostic.6                 IS #1D ( BYTE ):
VAL BYTE Prevent.Allow.Medium.Removal.6    IS #1E ( BYTE ):
--}}}  
--{{{  10 Byte Commands
VAL BYTE Define.Window.Parameters.10       IS #24 ( BYTE ):
VAL BYTE Get.Window.Parameters.10          IS #25 ( BYTE ):
VAL BYTE Read.Capacity.10                  IS #25 ( BYTE ):
VAL BYTE Read.CD.ROM.Capacity.10           IS #25 ( BYTE ):
VAL BYTE Read.10                           IS #28 ( BYTE ):
VAL BYTE Get.Message.10                    IS #28 ( BYTE ):
VAL BYTE Read.Generation                   IS #29 ( BYTE ): --Listed not defined
VAL BYTE Send.10                           IS #2A ( BYTE ):
VAL BYTE Send.Message.10                   IS #2A ( BYTE ):
VAL BYTE Write.10                          IS #2A ( BYTE ):
VAL BYTE Locate.10                         IS #2B ( BYTE ):
VAL BYTE Position.to.Element.10            IS #2B ( BYTE ):
VAL BYTE Seek.10                           IS #2B ( BYTE ):
VAL BYTE Erase.10                          IS #2C ( BYTE ):
VAL BYTE Read.Updated.Block.10             IS #2D ( BYTE ):
VAL BYTE Write.and.Verify.10               IS #2E ( BYTE ):
VAL BYTE Verify.10                         IS #2F ( BYTE ):
VAL BYTE Search.Data.High.10               IS #30 ( BYTE ):
VAL BYTE Medium.Position                   IS #30 ( BYTE ): --Listed not defined
VAL BYTE Search.Data.Equal.10              IS #31 ( BYTE ):
VAL BYTE Search.Data.Low.10                IS #32 ( BYTE ):
VAL BYTE Set.Limits.10                     IS #33 ( BYTE ):
VAL BYTE Get.Data.Status.10                IS #34 ( BYTE ):
VAL BYTE Pre.Fetch.10                      IS #34 ( BYTE ):
VAL BYTE Read.Position.10                  IS #34 ( BYTE ):
VAL BYTE Synchronize.Cache.10              IS #35 ( BYTE ):
VAL BYTE Lock.Unlock.Cache.10              IS #36 ( BYTE ):
VAL BYTE Read.Defect.Data.10               IS #37 ( BYTE ):
VAL BYTE Medium.Scan.10                    IS #38 ( BYTE ):
VAL BYTE Compare.10                        IS #39 ( BYTE ):
VAL BYTE Copy.and.Verify.10                IS #3A ( BYTE ):
VAL BYTE Write.Buffer.10                   IS #3B ( BYTE ):
VAL BYTE Read.Buffer.10                    IS #3C ( BYTE ):
VAL BYTE Update.Block.10                   IS #3D ( BYTE ):
VAL BYTE Read.Long.10                      IS #3E ( BYTE ):
VAL BYTE Write.Long.10                     IS #3F ( BYTE ):
VAL BYTE Change.Definition.10              IS #40 ( BYTE ):
VAL BYTE Write.Same.10                     IS #41 ( BYTE ):
VAL BYTE Read.Sub.Channel.10               IS #42 ( BYTE ):
VAL BYTE Read.TOC.10                       IS #43 ( BYTE ):
VAL BYTE Read.Header.10                    IS #44 ( BYTE ):
VAL BYTE Play.Audio.10                     IS #45 ( BYTE ):
VAL BYTE Play.Audio.MSF.10                 IS #47 ( BYTE ):
VAL BYTE Play.Audio.Track.Index.10         IS #48 ( BYTE ):
VAL BYTE Play.Audio.Track.Relative.10      IS #49 ( BYTE ): -- Naming
VAL BYTE Play.Track.Relative.10            IS #49 ( BYTE ): -- Discrepency
VAL BYTE Pause.Resume.10                   IS #4B ( BYTE ):
VAL BYTE Log.Select.10                     IS #4C ( BYTE ):
VAL BYTE Log.Sense.10                      IS #4D ( BYTE ):
VAL BYTE Mode.Select.10                    IS #55 ( BYTE ):
VAL BYTE Mode.Sense.10                     IS #5A ( BYTE ):
--}}}  
--{{{  12 Byte Commands
VAL BYTE Move.Medium.12                    IS #A5 ( BYTE ):
VAL BYTE Play.Audio.12                     IS #A5 ( BYTE ):
VAL BYTE Exchange.Medium.12                IS #A6 ( BYTE ):
VAL BYTE Get.Message.12                    IS #A8 ( BYTE ):
VAL BYTE Read.12                           IS #A8 ( BYTE ):
VAL BYTE Play.Audio.Track.Relative.12      IS #A9 ( BYTE ): -- Naming
VAL BYTE Play.Track.Relative.12            IS #A9 ( BYTE ): -- Discrepency
VAL BYTE Send.Message.12                   IS #AA ( BYTE ):
VAL BYTE Write.12                          IS #AA ( BYTE ):
VAL BYTE Erase.12                          IS #AC ( BYTE ):
VAL BYTE Write.and.Verify.12               IS #AE ( BYTE ):
VAL BYTE Verify.12                         IS #AF ( BYTE ):
VAL BYTE Search.Data.High.12               IS #B0 ( BYTE ):
VAL BYTE Search.Data.Equal.12              IS #B1 ( BYTE ):
VAL BYTE Search.Data.Low.12                IS #B2 ( BYTE ):
VAL BYTE Set.Limits.12                     IS #B3 ( BYTE ):
VAL BYTE Request.Volume.Element.Address.12 IS #B5 ( BYTE ):
VAL BYTE Send.Volume.Tag.12                IS #B6 ( BYTE ):
VAL BYTE Read.Defect.Data.12               IS #B7 ( BYTE ):
VAL BYTE Read.Element.Status.12            IS #B8 ( BYTE ):
--}}}  
--{{{  Buffer Sizes
VAL INT Command.Max                        IS 256:
--}}}  
--{{{  Frequently used definitions
VAL BYTE  SCSI.Non.Linked.Command                IS #00 (BYTE):
VAL BYTE  SCSI.Linked.Command                    IS #01 (BYTE):
VAL BYTE  SCSI.Linked.Command.With.Flag          IS #03 (BYTE):
--}}}  
