/*{{{  Header*/
/*#COMMENT "Copyright INMOS Limited 1990, 1991, 1992" */
/*#COMMENT "IMS F002C Product release SCSI Software libraries" */
/*------------------------------------------------------------------------------ */
/* */
/* Date        : 10_Decmber_1991 */
/* */
/* File Name   : SCSICOMS.H */
/* */
/* Project     : F002 - SCSI Tram Software */
/* */
/* Version     : 1.3 */
/* */
/* Division    : IQ Systems */
/* */
/* Limitations : This software may be distributed in source form. */
/* */
/* Description : SCSI Generic Intiator Mode interfaces to SCSICOMS.LIB       */
/* */
/*-------------------------------------------------------------------------- */
/* Schedule of Amendments */
/*-------------------------------------------------------------------------- */
/* 10/12/91 - PF Removed Wrappers to call occam indirectly                   */
/*-------------------------------------------------------------------------- */
/*}}}  */
#include "channel.h"
/*{{{  Define Data Transfer Mode*/
#pragma IMS_translate ( SCSI_Define_Data_Transfer_Mode , "SCSI.Define.Data.Transfer.Mode")

 void SCSI_Define_Data_Transfer_Mode ( Channel          *to_scsi_ha,
                                       Channel          *from_scsi_ha,
                                       const short int   data_transfer_mode,
                                       short int         *execution_status);

#pragma IMS_nolink( SCSI_Define_Data_Transfer_Mode )
/*}}}  */
/*{{{  Enable Initiator Mode*/
#pragma IMS_translate ( Enable_Initiator_Mode , "Enable.Initiator.Mode")

 void Enable_Initiator_Mode ( Channel    *to_scsi_ha,
                              Channel    *from_scsi_ha,
                              const char  initiator_id,
                              short int  *execution_status);

#pragma IMS_nolink( Enable_Initiator_Mode )
/*}}}  */
/*{{{  Enable Target Mode*/
#pragma IMS_translate ( Enable_Target_Mode , "Enable.Target.Mode")

 void Enable_Target_Mode    ( Channel   *to_target_ha,
                              Channel   *from_target_ha,
                              const char target_id,
                              short int   *execution_status);

#pragma IMS_nolink( Enable_Target_Mode )
/*}}}  */
/*{{{  Host Adaptor Device Driver Interface*/
#pragma IMS_translate ( SCSI_HADD_IF , "SCSI.HADD.IF")

 void SCSI_HADD_IF ( Channel       *to_scsi_ha,
                     Channel       *from_scsi_ha,
                     const char     target_id,
                     const char     lun,
                     const char     scsi_command_length,
                     const char     scsi_command[],
                     int            scsi_command_size,
                     const char     direction,
                     const long     rx_transfer_length,
                     char           rx_data[],
                     int            rx_data_size ,
                     const long     tx_transfer_length,
                     const char     tx_data[],
                     int            tx_data_size,
                     char          *msg_length,
                     char           message[],
                     int            message_size,
                     char          *scsi_status,
                     short int       *execution_status );

#pragma IMS_nolink( SCSI_HADD_IF )
/*}}}  */
/*{{{  Host Adaptor Device Driver Interface (Double Link)*/
#pragma IMS_translate ( SCSI_HADD_IF_DL , "SCSI.HADD.IF.DL")

 void SCSI_HADD_IF_DL ( Channel        *cmndata_to_scsi_ha,
                        Channel        *data_to_scsi_ha,
                        Channel        *cmndata_from_scsi_ha,
                        Channel        *data_from_scsi_ha,
                        const char      interval_offset,
                        const char      target_id,
                        const char      lun,
                        const char      command_length,
                        const char      scsi_command[],
                        int             scsi_command_size,
                        const char      direction,
                        const long      rx_transfer_length,
                        char            rx_data[],
                        int             rx_data_size,
                        const long      tx_transfer_length,
                        const char      tx_data[],
                        int             tx_data_size,
                        char           *msg_length,
                        char            message[],
                        int             message_size,
                        char           *scsi_status,
                        short int      *execution_status);

#pragma IMS_nolink( SCSI_HADD_IF_DL )
/*}}}  */
/*{{{  Initialise*/
#pragma IMS_translate ( SCSI_Initialise , "SCSI.Initialise")

 void SCSI_Initialise ( Channel         *to_scsi_ha,
                        Channel         *from_scsi_ha,
                        const short int  data_phase_time_out,
                        const short int  interrupt_time_out,
                        const char       parity_generation,
                        const char       parity_checking,
                        const char       slow_cable_mode,
                        const char       reset_controller,
                        const char       reset_scsi_bus,
                        const char       perform_self_test,
                        short int       *execution_status);

#pragma IMS_nolink( SCSI_Initialise )
/*}}}  */
/*{{{  Reset_SCSI_Bus*/
#pragma IMS_translate ( Reset_SCSI_Bus , "Reset.SCSI.Bus")

 void Reset_SCSI_Bus( Channel  *to_scsi_ha,
                      Channel  *from_scsi_ha,
                      short int  *execution_status);

#pragma IMS_nolink( Reset_SCSI_Bus )
/*}}}  */
/*{{{  Analyse Subsystem*/
#pragma IMS_translate ( Analyse_Subsystem  , "Analyse.Subsystem" )

 void Analyse_Subsystem     ( Channel   *to_scsi_ha,
                              Channel   *from_scsi_ha,
                              short int   *execution_status);

#pragma IMS_nolink( Analyse_Subsystem )
/*}}}  */
/*{{{  Read Subsystem Not Error*/
#pragma IMS_translate ( Read_Subsystem_Not_Error, "Read.Subsystem.not.Error")

 void Read_Subsystem_Not_Error (Channel *to_scsi_ha,
                                Channel *from_scsi_ha,
                                char    *subsystem_not_error_value,
                                short int *execution_status);

#pragma IMS_nolink( Read_Subsystem_Not_Error )
/*}}}  */
/*{{{  Reset Subsystem*/
#pragma IMS_translate ( Reset_Subsystem, "Reset.Subsystem")

 void Reset_Subsystem ( Channel   *to_scsi_ha,
                        Channel   *from_scsi_ha,
                        short int   *execution_status);

#pragma IMS_nolink( Reset_Subsystem )
/*}}}  */
/*{{{  SCSI_Select_Mode*/
#pragma IMS_translate ( SCSI_Select_Mode , "SCSI.Select.Mode")

 void SCSI_Select_Mode ( Channel    *to_scsi_ha,
                         Channel    *from_scsi_ha,
                         const char  selection_mode,
                         short int    *execution_status);

#pragma IMS_nolink( SCSI_Select_Mode )
/*}}}  */
