/*{{{  Header */
/*#COMMENT "Copyright INMOS Limited 1990, 1991, 1992" */
/*#COMMENT "IMS F002C Product Release SCSI Software Libraries" */
/*------------------------------------------------------------------------------ */
/* */
/* Date        : 04-Apr-1990 */
/* */
/* File Name   : SCSIESTA.INC */
/* */
/* Project     : IMS F002 - SCSI Tram Software */
/* */
/* Version     : 1.0 */
/* */
/* Division    : IQ Systems */
/* */
/* Limitations : This software may be distributed in source form. */
/* */
/* Description : Error Messages transmitted on SCSI.E.Execution.Status */
/*               of FROM.SCSI */
/* */
/*------------------------------------------------------------------------------ */
/* Schedule of Amendments */
/*------------------------------------------------------------------------------ */
/* */
/*------------------------------------------------------------------------------ */
/*}}}  */
/*{{{  Constants */
#define SCSI_E_Good  0x0000
#define SCSI_E_Bad_SCSI_Status  0x0001
#define SCSI_E_Command_Not_Complete  0x0002
#define SCSI_E_Incorrect_IO_Process_Number  0x0003
#define SCSI_E_SCSI_Bus_Parity_Error  0x0004
#define SCSI_E_Data_In_Failure  0x0005
#define SCSI_E_Bad_Data_In_Returned_Packet_Size  0x0006
#define SCSI_E_Data_Out_Failure  0x0007
#define SCSI_E_Bad_Data_Out_Returned_Packet_Size  0x0008
#define SCSI_E_Data_In_Time_Out  0x0009
#define SCSI_E_Data_Out_Time_Out  0x000A
#define SCSI_E_Command_Time_Out  0x000B
#define SCSI_E_Status_Time_Out  0x000C
#define SCSI_E_Controller_Reset_Time_Out  0x000D
#define SCSI_E_Bus_Reset_Time_Out  0x000E
#define SCSI_E_Reselected  0x000F
#define SCSI_E_Function_Not_Complete  0x0010
#define SCSI_E_Disconnected  0x0011
#define SCSI_E_Not_Bus_Service  0x0012
#define SCSI_E_Sequence_Not_Complete  0x0013
#define SCSI_E_Premature_Phase_Change  0x0014
#define SCSI_E_Target_Did_Not_Assert_ATN  0x0015
#define SCSI_E_Target_Did_Not_Assert_Message_Out  0x0016
#define SCSI_E_Selection_Time_Out  0x0017
#define SCSI_E_Undocumented_Error  0x0018
#define SCSI_E_Data_In_Abort  0x0019
#define SCSI_E_Data_Out_Abort  0x001A
#define SCSI_E_Unexpected_Phase_Change  0x001B
#define SCSI_E_Failed_Self_Test  0x001C
#define SCSI_E_Invalid_Interval_Offset  0x001D
#define SCSI_E_Bus_Reset  0x001E
#define SCSI_E_Bad_Message_Length  0x001F
#define SCSI_E_Bad_Command_Length  0x0020
#define SCSI_E_Bad_LUN  0x0021
#define SCSI_E_Bad_Device_ID  0x0022
#define SCSI_E_Invalid_Data_Transfer_Size  0x0023
#define SCSI_E_Interrupt_Time_Out  0x0024
#define SCSI_E_Bad_Data_Phase_Time_Out  0x0025
#define SCSI_E_Bad_Interrupt_Time_Out  0x0026
#define SCSI_E_Invalid_Transfer_Mode  0x0027

#define SCSI_E_Software_Error  0x07FE
#define SCSI_E_Not_Implemented  0x07FF

/* #0027..#07FD  reserved by INMOS for future use and additional products. */
/* #0800..#FFFF  available to user applications to add extra status info */
/*               after calls to SCSI library */

/*}}}  */

