/*{{{  Header*/
/*#COMMENT "Copyright INMOS Limited 1990, 1991, 1992" */
/*#COMMENT "IMS F002C Product release SCSI Software libraries" */
/*------------------------------------------------------------------------------ */
/* */
/* Date        : 10_Decmber_1991 */
/* */
/* File Name   : tgtmode.h */
/* */
/* Project     : F002 - SCSI Tram Software */
/* */
/* Version     : 1.3 */
/* */
/* Division    : IQ Systems */
/* */
/* Limitations : This software may be distributed in source form. */
/* */
/* Description : SCSI Target Mode interfaces to TGTMODE.LIB       */
/* */
/*-------------------------------------------------------------------------- */
/* Schedule of Amendments */
/*-------------------------------------------------------------------------- */
/* 10/12/91 - PF Removed Wrappers to call occam indirectly                   */
/*-------------------------------------------------------------------------- */
/*}}}  */
#include <channel.h>
/*{{{  SCSI_T_Await_Selection*/
#pragma IMS_translate ( SCSI_T_Await_Selection ,"SCSI.T.Await.Selection")

 void SCSI_T_Await_Selection ( Channel    *to_target_controller,
                               Channel    *from_target_controller,
                               const char ignore_bus_resets,
                               char       *initiator_id,
                               char       *scsi_command_length,
                               char        scsi_command[],
                               int         scsi_command_size,
                               char       *msg_length,
                               char        message[],
                               int         message_size,
                               short int  *execution_status );

#pragma IMS_nolink ( SCSI_T_Await_Selection )
/*}}}  */
/*{{{  SCSI_T_Data_In_Phase*/
#pragma IMS_translate ( SCSI_T_Data_In_Phase ,"SCSI.T.Data.In.Phase")

 void SCSI_T_Data_In_Phase ( Channel       *to_target_controller,
                             Channel       *from_target_controller,
                             const long int transfer_count,
                             const char     buffer[],
                             int            buffer_size,
                             short int       *execution_status );

#pragma IMS_nolink ( SCSI_T_Data_In_Phase )
/*}}}  */
/*{{{  SCSI_T_Data_In_Phase_DL*/
#pragma IMS_translate ( SCSI_T_Data_In_Phase_DL ,"SCSI.T.Data.In.Phase.DL")

 void SCSI_T_Data_In_Phase_DL ( Channel       *cmnd_to_target_controller,
                                Channel       *data_to_target_controller,
                                Channel       *cmnd_from_target_controller,
                                Channel       *data_from_target_controller,
                                const long int transfer_count,
                                const char     interval_offset,
                                const char     buffer[],
                                int            buffer_size,
                                short int       *execution_status );

#pragma IMS_nolink ( SCSI_T_Data_In_Phase_DL )
/*}}}  */
/*{{{  SCSI_T_Data_Out_Phase*/
#pragma IMS_translate ( SCSI_T_Data_Out_Phase ,"SCSI.T.Data.Out.Phase")

 void SCSI_T_Data_Out_Phase ( Channel       *to_target_controller,
                              Channel       *from_target_controller,
                              const long int transfer_count,
                              char           buffer[],
                              int            buffer_size,
                              short int       *execution_status );

#pragma IMS_nolink ( SCSI_T_Data_Out_Phase )
/*}}}  */
/*{{{  SCSI_T_Data_Out_Phase_DL*/
#pragma IMS_translate ( SCSI_T_Data_Out_Phase_DL ,"SCSI.T.Data.Out.Phase.DL")

 void SCSI_T_Data_Out_Phase_DL ( Channel       *cmnd_to_target_controller,
                                 Channel       *data_to_target_controller,
                                 Channel       *cmnd_from_target_controller,
                                 Channel       *data_from_target_controller,
                                 const long int transfer_count,
                                 const char     interval_offset,
                                 char           buffer[],
                                 int            buffer_size,
                                 short int       *execution_status );

#pragma IMS_nolink ( SCSI_T_Data_Out_Phase_DL )
/*}}}  */
/*{{{  SCSI_T_Disconnect_From_Bus*/
#pragma IMS_translate ( SCSI_T_Disconnect_From_Bus ,"SCSI.T.Disconnect.From.Bus")

 void SCSI_T_Disconnect_From_Bus ( Channel *to_target_controller,
                                   Channel *from_target_controller,
                                   short int *execution_status );

#pragma IMS_nolink ( SCSI_T_Disconnect_From_Bus )
/*}}}  */
/*{{{  SCSI_T_Message_In*/
#pragma IMS_translate ( SCSI_T_Message_In ,"SCSI.T.Message.In")

 void SCSI_T_Message_In ( Channel *to_target_controller,
                          Channel *from_target_controller,
                          char    *msg_length,
                          char     message[],
                          int      message_size,
                          short int *execution_status );

#pragma IMS_nolink ( SCSI_T_Message_In )
/*}}}  */
/*{{{  SCSI_T_Message_Out*/
#pragma IMS_translate ( SCSI_T_Message_Out ,"SCSI.T.Message.Out")

 void SCSI_T_Message_Out ( Channel    *to_target_controller,
                           Channel    *from_target_controller,
                           const char *msg_length,
                           const char  message[],
                           int         message_size,
                           short int    *execution_status );

#pragma IMS_nolink ( SCSI_T_Message_Out )
/*}}}  */
/*{{{  SCSI_T_Reconnect_To_Bus*/
#pragma IMS_translate ( SCSI_T_Reconnect_To_Bus ,"SCSI.T.Reconnect.To.Bus")

 void SCSI_T_Reconnect_To_Bus ( Channel   *to_target_controller,
                                Channel   *from_target_controller,
                                const char initiator_id,
                                short int   *execution_status );

#pragma IMS_nolink ( SCSI_T_Reconnect_To_Bus )
/*}}}  */
/*{{{  SCSI_T_Status*/
#pragma IMS_translate ( SCSI_T_Status ,"SCSI.T.Status")

 void SCSI_T_Status ( Channel   *to_target_controller,
                      Channel   *from_target_controller,
                      const char scsi_status,
                      short int   *execution_status );

#pragma IMS_nolink ( SCSI_T_Status )
/*}}}  */
/*{{{  SCSI_T_Status_And_Message_In*/
#pragma IMS_translate ( SCSI_T_Status_And_Message_In ,"SCSI.T.Status.And.Message.In")

 void SCSI_T_Status_And_Message_In ( Channel   *to_target_controller,
                                     Channel   *from_target_controller,
                                     const char status,
                                     const char control_byte,
                                     const char msg_length,
                                     const char message[],
                                     int        message_size,
                                     short int   *execution_status );

#pragma IMS_nolink ( SCSI_T_Status_And_Message_In )
/*}}}  */
